//***********************************************************************************
//***********************************************************************************
//***********************************************************************************
//***********************************************************************************
//***********************************************************************************
//
//
//
//  delib.pas
//  project: DELIB
//
//
//  (c) DEDITEC GmbH, 2009-2020
//  web: http://www.deditec.de/
//  mail: vertrieb@deditec.de
//
//
//***********************************************************************************
//***********************************************************************************
//***********************************************************************************
//***********************************************************************************
//***********************************************************************************
//
    
// all Modul-ID's
const
    USB_Interface8                                          = 1;
    USB_CAN_STICK                                           = 2;
    USB_LOGI_500                                            = 3;
    USB_SER_DEBUG                                           = 4;
    RO_SER                                                  = 5;
    USB_BITP_200                                            = 6;
    RO_USB1                                                 = 7;
    RO_USB                                                  = 7;
    RO_ETH                                                  = 8;
    USB_MINI_STICK                                          = 9;
    USB_LOGI_18                                             = 10;
    RO_CAN                                                  = 11;
    USB_SPI_MON                                             = 12;
    USB_WATCHDOG                                            = 13;
    USB_OPTOIN_8                                            = 14;
    USB_RELAIS_8                                            = 14;
    USB_OPTOIN_8_RELAIS_8                                   = 15;
    USB_OPTOIN_16_RELAIS_16                                 = 16;
    USB_OPTOIN_32                                           = 16;
    USB_RELAIS_32                                           = 16;
    USB_OPTOIN_32_RELAIS_32                                 = 17;
    USB_OPTOIN_64                                           = 17;
    USB_RELAIS_64                                           = 17;

    BS_USB_8                                                = 15;
    BS_USB_16                                               = 16;
    BS_USB_32                                               = 17;

    USB_TTL_32                                              = 18;
    USB_TTL_64                                              = 18;
    RO_ETH_INTERN                                           = 19;

    BS_SER                                                  = 20;
    BS_CAN                                                  = 21;
    BS_ETH                                                  = 22;

    NET_ETH                                                 = 23;

    RO_CAN2                                                 = 24;           
    RO_USB2                                                 = 25;       
    RO_ETH_LC                                               = 26;       
    //
    ETH_RELAIS_8                                            = 27;
    ETH_OPTOIN_8                                            = 27;
    ETH_O4_R4_ADDA                                          = 28;
    //
    ETHERNET_MODULE                                         = 29;
    //
    ETH_TTL_64                                              = 30;
    //
    NET_USB2                                                = 31;
    NET_ETH_LC                                              = 32;
    NET_USB1                                                = 33;
    NET_SER                                                 = 34;
    NET_CAN_OPEN                                            = 35;
    NET_RAS_PI                                              = 36;
	
	USB_CANOPEN_STICK                                       = 37;

	ETH_CUST_0                                              = 38;
	
	WEU_RELAIS_8                                            = 39;
    WEU_OPTO_8                                              = 39;
    WEU_E_RELAIS_8                                          = 40;
	
    BS_WEU                                              	= 41;
	BS_WEU_E                                       			= 42;
	
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// Declarations


// ----------------------------------------------------------------------------
// Special Function-Codes
const
    DAPI_SPECIAL_CMD_GET_MODULE_CONFIG                      = $01;
    DAPI_SPECIAL_CMD_TIMEOUT                                = $02;
    DAPI_SPECIAL_CMD_DI                                     = $0a;
    DAPI_SPECIAL_CMD_SET_DIR_DX_1                           = $03;
    DAPI_SPECIAL_CMD_SET_DIR_DX_8                           = $04;
    DAPI_SPECIAL_CMD_GET_MODULE_VERSION                     = $05;
    DAPI_SPECIAL_CMD_DA                                     = $06;
    DAPI_SPECIAL_CMD_WATCHDOG                               = $07;
    DAPI_SPECIAL_CMD_COUNTER                                = $08;
    DAPI_SPECIAL_CMD_AD                                     = $09;
    DAPI_SPECIAL_CMD_CNT48                                  = $0b;
    DAPI_SPECIAL_CMD_SW_FIFO                          		= $0c;
    DAPI_SPECIAL_CMD_MODULE_REBOOT                          = $0d;
    DAPI_SPECIAL_CMD_MODULE_RESCAN                          = $0e;
    DAPI_SPECIAL_CMD_RESTART_CHECK_MODULE_CONFIG            = $0f;
    DAPI_SPECIAL_CMD_PWM                                    = $13;
    DAPI_SPECIAL_CMD_GET_DIR_DX_1                           = $14;
    DAPI_SPECIAL_CMD_GET_DIR_DX_8                           = $15;
    DAPI_SPECIAL_CMD_CANOPEN_STICK                          = $16;

    // values for PAR1
    DAPI_SPECIAL_GET_MODULE_CONFIG_PAR_DI                   = 1;
    DAPI_SPECIAL_GET_MODULE_CONFIG_PAR_DI_FF                = 7;
    DAPI_SPECIAL_GET_MODULE_CONFIG_PAR_DI_COUNTER           = 8;
    DAPI_SPECIAL_GET_MODULE_CONFIG_PAR_DO                   = 2;
    DAPI_SPECIAL_GET_MODULE_CONFIG_PAR_DX                   = 3;
    DAPI_SPECIAL_GET_MODULE_CONFIG_PAR_AD                   = 4;
    DAPI_SPECIAL_GET_MODULE_CONFIG_PAR_DA                   = 5;
    DAPI_SPECIAL_GET_MODULE_CONFIG_PAR_TEMP                 = 9;
    DAPI_SPECIAL_GET_MODULE_CONFIG_PAR_STEPPER              = 6;
    DAPI_SPECIAL_GET_MODULE_CONFIG_PAR_CNT48                = 10;
    DAPI_SPECIAL_GET_MODULE_CONFIG_PAR_PULSE_GEN            = 11;
    DAPI_SPECIAL_GET_MODULE_CONFIG_PAR_PWM_OUT              = 12;
    DAPI_SPECIAL_GET_MODULE_CONFIG_PAR_HW_INTERFACE1        = 13;
    DAPI_SPECIAL_GET_MODULE_CONFIG_PAR_SW_FEATURE1          = 14;
    DAPI_SPECIAL_GET_MODULE_CONFIG_PAR_HW_GROUP             = 15;
    DAPI_SPECIAL_GET_MODULE_CONFIG_PAR_SW_CLASS             = 16;
    DAPI_SPECIAL_GET_MODULE_CONFIG_PAR_MODULE_ID            = 17;
    //
    DAPI_SPECIAL_GET_MODULE_PAR_VERSION_0                   = 0;
    DAPI_SPECIAL_GET_MODULE_PAR_VERSION_1                   = 1;
    DAPI_SPECIAL_GET_MODULE_PAR_VERSION_2                   = 2;
    DAPI_SPECIAL_GET_MODULE_PAR_VERSION_3                   = 3;
    //
    DAPI_SPECIAL_TIMEOUT_SET_VALUE_SEC                      = 1;
    DAPI_SPECIAL_TIMEOUT_ACTIVATE                           = 2;
	DAPI_SPECIAL_TIMEOUT_ACTIVATE_AUTO_REACTIVATE			= 10;
	DAPI_SPECIAL_TIMEOUT_ACTIVATE_SECURE_OUTPUTS			= 11;
    DAPI_SPECIAL_TIMEOUT_DEACTIVATE                         = 3;
    DAPI_SPECIAL_TIMEOUT_GET_STATUS                         = 4;
	DAPI_SPECIAL_TIMEOUT_DO_VALUE_LOAD_DEFAULT				= 5;
	DAPI_SPECIAL_TIMEOUT_DO_VALUE_MASK_WR_CLR32				= 6;
	DAPI_SPECIAL_TIMEOUT_DO_VALUE_MASK_RD_CLR32				= 7;
	DAPI_SPECIAL_TIMEOUT_DO_VALUE_MASK_WR_SET32				= 8;
	DAPI_SPECIAL_TIMEOUT_DO_VALUE_MASK_RD_SET32				= 9;
    //  
    DAPI_SPECIAL_DI_FF_FILTER_VALUE_SET                     = 1;
    DAPI_SPECIAL_DI_FF_FILTER_VALUE_GET                     = 2;
    //
    DAPI_SPECIAL_RO_AD_FIFO_ACTIVATE                        = 2;
    DAPI_SPECIAL_RO_AD_FIFO_DEACTIVATE                      = 3;
    DAPI_SPECIAL_RO_AD_FIFO_GET_STATUS                      = 4;
    DAPI_SPECIAL_RO_AD_FIFO_SET_INTERVAL_MS                 = 5;
    DAPI_SPECIAL_RO_AD_FIFO_SET_CHANNEL                     = 6;
    DAPI_SPECIAL_RO_AD_FIFO_INIT                            = 7;
	//
    DAPI_SPECIAL_AD_READ_MULTIPLE_AD                        = 1;
    DAPI_SPECIAL_AD_FILTER_SET                              = 8;
    DAPI_SPECIAL_AD_FILTER_GET                              = 9;
    //
    DAPI_SPECIAL_DA_PAR_DA_LOAD_DEFAULT                     = 1;
    DAPI_SPECIAL_DA_PAR_DA_SAVE_EEPROM_CONFIG               = 2;
    DAPI_SPECIAL_DA_PAR_DA_LOAD_EEPROM_CONFIG               = 3;
    //
    DAPI_SPECIAL_WATCHDOG_SET_TIMEOUT_MSEC                  = 1;
    DAPI_SPECIAL_WATCHDOG_GET_TIMEOUT_MSEC                  = 2;
    DAPI_SPECIAL_WATCHDOG_GET_STATUS                        = 3;
    DAPI_SPECIAL_WATCHDOG_GET_WD_COUNTER_MSEC               = 4;
    DAPI_SPECIAL_WATCHDOG_GET_TIMEOUT_RELAIS_COUNTER_MSEC   = 5;
    DAPI_SPECIAL_WATCHDOG_SET_TIMEOUT_REL1_COUNTER_MSEC     = 6;
    DAPI_SPECIAL_WATCHDOG_SET_TIMEOUT_REL2_COUNTER_MSEC     = 7;
    //
    DAPI_SPECIAL_COUNTER_LATCH_ALL                          = 1;
    DAPI_SPECIAL_COUNTER_LATCH_ALL_WITH_RESET               = 2;
	DAPI_SPECIAL_COUNTER_PRELOAD_SET						= 3;
	DAPI_SPECIAL_COUNTER_PRELOAD_GET						= 4;
	DAPI_SPECIAL_COUNTER_MODE_SET							= 5;
	DAPI_SPECIAL_COUNTER_MODE_GET							= 6;
	DAPI_SPECIAL_COUNTER_GET								= 7;
    //
    DAPI_SPECIAL_CNT48_RESET_SINGLE                         = 1;
    DAPI_SPECIAL_CNT48_RESET_GROUP8                         = 2;
    DAPI_SPECIAL_CNT48_LATCH_GROUP8                         = 3;
    DAPI_SPECIAL_CNT48_DI_GET1                              = 4;
    //
	DAPI_SPECIAL_SW_FIFO_INIT_AND_CLEAR						= 1;
	DAPI_SPECIAL_SW_FIFO_ACTIVATE							= 2;
	DAPI_SPECIAL_SW_FIFO_DEACTIVATE							= 3;
	DAPI_SPECIAL_SW_FIFO_SET_SUBMODULE						= 4;
	DAPI_SPECIAL_SW_FIFO_SET_CHANNEL						= 5;
	DAPI_SPECIAL_SW_FIFO_SET_FREQUENCY_HZ					= 6;
	DAPI_SPECIAL_SW_FIFO_SET_MODE							= 7;
	
	DAPI_SPECIAL_SW_FIFO_GET_STATUS							= $81;		// Bit 7 ist gesetzt bei Lesebefehlen
	DAPI_SPECIAL_SW_FIFO_GET_BYTES_FREE						= $82;
	DAPI_SPECIAL_SW_FIFO_GET_ACTIVITY						= $83;
	DAPI_SPECIAL_SW_FIFO_GET_SUBMODULE						= $84;
	DAPI_SPECIAL_SW_FIFO_GET_CHANNEL						= $85;
	DAPI_SPECIAL_SW_FIFO_GET_FREQUENCY_HZ					= $86;
	DAPI_SPECIAL_SW_FIFO_GET_MODE							= $87;
	DAPI_SPECIAL_SW_FIFO_GET_BYTES_PER_SAMPLE				= $88;
    //
    DAPI_SPECIAL_PWM_FREQ_LOAD_DFAULT                       = 1;
    DAPI_SPECIAL_PWM_FREQ_SAVE_EEPROM                       = 2;
    DAPI_SPECIAL_PWM_FREQ_LOAD_EEPROM                       = 3;
    DAPI_SPECIAL_PWM_FREQ_SET                               = 4;
    DAPI_SPECIAL_PWM_FREQ_READBACK                          = 5;
    //
    DAPI_SPECIAL_CANOPEN_STICK_FLUSH			            = 1;
    DAPI_SPECIAL_CANOPEN_STICK_SDO_READ			            = 2;

    // values for PAR2
    DAPI_SPECIAL_AD_CH0_CH15                                = 0;
    DAPI_SPECIAL_AD_CH16_CH31                               = 1;
    DAPI_SPECIAL_AD_CH32_CH47                               = 2;
    DAPI_SPECIAL_AD_CH48_CH63                               = 3;

// ----------------------------------------------------------------------------
// DapiScanModules-Codes
const
    DAPI_SCANMODULE_GET_MODULES_AVAILABLE                   = 1;

// ----------------------------------------------------------------------------
// SOFTWARE Features Class
    DAPI_SW_CLASS_TYPE_OF_MODULE_IDENTIFICATION             = $1;           // Bit 0
    DAPI_SW_CLASS_DI_DO_DX_CHANNELS                         = $2;           // Bit 1
    DAPI_SW_CLASS_AD_DA_CHANNELS                            = $4;           // Bit 2

// ----------------------------------------------------------------------------
// Hardware Group
    DAPI_HW_GROUP_RO                                        = $1;           // Bit 0
    DAPI_HW_GROUP_LOGICANALYZER                             = $2;           // Bit 1
    DAPI_HW_GROUP_DI_DO_AD_DA                               = $4;           // Bit 2
    DAPI_HW_GROUP_USB                                       = $8;           // Bit 3
    DAPI_HW_GROUP_BS                                        = $10;          // Bit 4
    DAPI_HW_GROUP_NET                                       = $20;          // Bit 5
    DAPI_HW_GROUP_ETH                                       = $40;          // Bit 6
    DAPI_HW_GROUP_CUST                                      = $80;          // Bit 7

// --------------------------------------------------------
// Software Feature Bits
    DAPI_SW_FEATURE_BIT_SUPPORTED_BY_FIRMWARE               = $00000001;
    DAPI_SW_FEATURE_BIT_RO_AD_SOFTWARE_FIFO                 = $00000002;
	DAPI_SW_FEATURE_BIT_SW_FIFO								= $00000100;
    DAPI_SW_FEATURE_BIT_CFG_DO_CMD_SET_CLR_BIT_32           = $00000004;
    DAPI_SW_FEATURE_BIT_EEPROM_RN23                         = $00000008;
    DAPI_SW_FEATURE_BIT_EEPROM_E2_2K                        = $00000020;
    DAPI_SW_FEATURE_BIT_EEPROM_E2_32K                       = $00000040;
    DAPI_SW_FEATURE_BIT_EEPROM_FS_SUPPORT                   = $00000080;
    DAPI_SW_FEATURE_BIT_DX_1_MODE                           = $00000010;
    DAPI_SW_FEATURE_BIT_AUTO_OUTPUTS_OFF_TIMEOUT            = $02000000;
	DAPI_SW_FEATURE_BIT_AUTO_OUTPUTS_OFF_TIMEOUT_WITH_MASK	= $00008000;
    DAPI_SW_FEATURE_BIT_SUPP_INDIVIDUAL_CH_NAMES            = $00001000;
    DAPI_SW_FEATURE_BIT_DEV_IO_REG_ERR_SUPP                 = $00002000;
    DAPI_SW_FEATURE_BIT_SUPP_SYSTEM_INFO                    = $00004000;

    DAPI_SW_FEATURE_BIT_CFG_WATCHDOG                        = $10000000;

    DAPI_SW_FEATURE_BIT_CFG_DI                              = $20000000;
    DAPI_SW_FEATURE_BIT_CFG_DI_CNT                          = $40000000;
    DAPI_SW_FEATURE_BIT_CFG_DI_CNT_LATCH                    = $00080000;
    DAPI_SW_FEATURE_BIT_CFG_DI_FF                           = $80000000;

    DAPI_SW_FEATURE_BIT_CFG_DO                              = $01000000;
    DAPI_SW_FEATURE_BIT_CFG_DO_WITH_TIMER                   = $00040000;

    DAPI_SW_FEATURE_BIT_CFG_PWM_OUT                         = $04000000;

    DAPI_SW_FEATURE_BIT_CFG_DX                              = $08000000;

    DAPI_SW_FEATURE_BIT_CFG_DA                              = $00100000;
    DAPI_SW_FEATURE_BIT_CFG_AD                              = $00200000;

    DAPI_SW_FEATURE_BIT_CFG_CNT_OUT32                       = $00400000;
    DAPI_SW_FEATURE_BIT_CFG_CNT_IN48                        = $00800000;

    DAPI_SW_FEATURE_BIT_CFG_TEMP                            = $00010000;
    DAPI_SW_FEATURE_BIT_CFG_STEPPER                         = $00020000;

// --------------------------------------------------------
// Hardware Interface Bits
    DAPI_HW_INTERFACE_BIT_SUPPORTED_BY_FIRMWARE             = $00000001;
    DAPI_HW_INTERFACE_BIT_CFG_ETH                           = $00000002;
    DAPI_HW_INTERFACE_BIT_CFG_CAN                           = $00000004;
    DAPI_HW_INTERFACE_BIT_CFG_RS232                         = $00000008;
    DAPI_HW_INTERFACE_BIT_CFG_RS232_RS485                   = $00000010;
    DAPI_HW_INTERFACE_BIT_CFG_USB1                          = $00000020;
    DAPI_HW_INTERFACE_BIT_CFG_USB2                          = $00000040;
    DAPI_HW_INTERFACE_BIT_CFG_CANOPEN                       = $00000080;

    DAPI_HW_INTERFACE_PRODUCT_ID_MASK                       = $FF000000;
    DAPI_HW_INTERFACE_PRODUCT_ID_RO                         = $01000000;
    DAPI_HW_INTERFACE_PRODUCT_ID_RO2                        = $02000000;
    DAPI_HW_INTERFACE_PRODUCT_ID_BS                         = $03000000;
    DAPI_HW_INTERFACE_PRODUCT_ID_NET                        = $04000000;
    DAPI_HW_INTERFACE_PRODUCT_ID_NET_IP                     = $05000000;
    DAPI_HW_INTERFACE_PRODUCT_ID_CANOPEN_STICK       		= $06000000;

// --------------------------------------------------------
// TCP Feature Bits
    DAPI_TCP_FEATURE_BIT_SUPPORTED_BY_FIRMWARE              = $00000001;
    DAPI_TCP_FEATURE_BIT_SUPP_RTC                           = $00000002;
    DAPI_TCP_FEATURE_BIT_SUPP_SYSTEM_INFO                   = $00000004;
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// Prototypes for DELIB-Functions
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------

// ----------------------------------------------------------------------------
//  
function    DapiOpenModule(moduleID:Longint;nr:Longint): Longint; stdcall; external 'delib.dll'
// left out (not possible): DapiOpenModuleEx
function    DapiCloseModule(handle:Longint): Longint; stdcall; external 'delib.dll'

function    DapiScanModule(moduleID:Longint;cmd:LongInt): Longint; stdcall; external 'delib.dll'
function    DapiScanAllModulesAvailable(todo:Longint): Longint; stdcall; external 'delib.dll'
function    DapiScanAllModulesAvailableListEcecute(nr:longint; todo:longint): Longint; stdcall; external 'delib.dll'

function    DapiGetDELIBVersion(mode:Longint;par:Longint): Longint; stdcall; external 'delib.dll'

function    DapiPing(handle:Longint;value:Longint): Longint; stdcall; external 'delib.dll'

// ----------------------------------------------------------------------------
// Register Access
procedure   DapiWriteByte(handle:Longint; adress:Longint; value:Longint); stdcall; external 'delib.dll'
procedure   DapiWriteWord(handle:Longint; adress:Longint;value:Longint); stdcall; external 'delib.dll'
procedure   DapiWriteLong(handle:Longint; adress:Longint;value:Longint); stdcall; external 'delib.dll'
// left out (not possible): DapiWriteLongLong

function    DapiReadByte(handle:Longint; adress:Longint): Longint; stdcall; external 'delib.dll'
function    DapiReadWord(handle:Longint; adress:Longint): Longint; stdcall; external 'delib.dll'
function    DapiReadLong(handle:Longint; adress:Longint): Longint; stdcall; external 'delib.dll'
// left out (not possible): DapiReadLongLong

// ----------------------------------------------------------------------------
// Error Handling
function    DapiGetLastError(): Longint; stdcall; external 'delib.dll'
// left out (not possible): DapiGetLastErrorText
procedure   DapiClearLastError(); stdcall; external 'delib.dll'

function    DapiGetLastErrorByHandle(handle:longint): Longint; stdcall; external 'delib.dll'
procedure   DapiClearLastErrorByHandle(handle:longint); stdcall; external 'delib.dll'

// ----------------------------------------------------------------------------
// Digital Inputs
function    DapiDIGet1(handle:Longint; ch:Longint): Longint; stdcall; external 'delib.dll'
function    DapiDIGet8(handle:Longint; ch:Longint): Longint; stdcall; external 'delib.dll'
function    DapiDIGet16(handle:Longint; ch:Longint): Longint; stdcall; external 'delib.dll'
function    DapiDIGet32(handle:Longint; ch:Longint): Longint; stdcall; external 'delib.dll'
// left out (not possible): DapiDIGet64

function    DapiDIGetFF32(handle:Longint; ch:Longint): Longint; stdcall; external 'delib.dll'
function    DapiDIGetCounter(handle:Longint; ch:Longint; mode:Longint): Longint; stdcall; external 'delib.dll'

// ----------------------------------------------------------------------------
// Digital Outputs
procedure   DapiDOSet1 (handle:Longint; ch:Longint; data:Longint); stdcall; external 'delib.dll'
procedure   DapiDOSet8 (handle:Longint; ch:Longint; data:Longint); stdcall; external 'delib.dll'
procedure   DapiDOSet16(handle:Longint; ch:Longint; data:Longint); stdcall; external 'delib.dll'
procedure   DapiDOSet32(handle:Longint; ch:Longint; data:Longint); stdcall; external 'delib.dll'
// left out (not possible): DapiDOSet64

function    DapiDOReadback32(handle:Longint; ch:Longint): Longint; stdcall; external 'delib.dll'
// left out (not possible): DapiDOReadback64

procedure   DapiDOSet1_WithTimer(handle:Longint; ch:Longint; data:Longint; time_ms:Longint); stdcall; external 'delib.dll'
procedure   DapiDOSetBit32(handle:Longint; ch:Longint; data:Longint); stdcall; external 'delib.dll'
procedure   DapiDOClrBit32(handle:Longint; ch:Longint; data:Longint); stdcall; external 'delib.dll'
// ----------------------------------------------------------------------------
// Analog Inputs
function    DapiADGet(handle:Longint; ch:Longint): Longint; stdcall; external 'delib.dll'
// left out (not possible): DapiADGetValueModeUnit
function    DapiADGetVolt(handle:Longint; ch:Longint): single; stdcall; external 'delib.dll'
function    DapiADGetmA(handle:Longint; ch:Longint): single; stdcall; external 'delib.dll'
procedure   DapiADSetMode(handle:Longint; ch:Longint; mode:Longint); stdcall; external 'delib.dll'
function    DapiADGetMode(handle:Longint; ch:Longint): Longint; stdcall; external 'delib.dll'

// ----------------------------------------------------------------------------
// Analog Outputs
procedure   DapiDASet(handle:Longint; ch:Longint; data:Longint); stdcall; external 'delib.dll'
procedure   DapiDASetVolt(handle:Longint; ch:Longint; data: single); stdcall; external 'delib.dll'
procedure   DapiDASetmA(handle:Longint; ch:Longint; data:single); stdcall; external 'delib.dll'
// left out (not possible): DapiDAGetValueModeUnit
procedure   DapiDASetMode(handle:Longint; ch:Longint; mode:Longint); stdcall; external 'delib.dll'
function    DapiDAGetMode(handle:Longint; ch:Longint): Longint; stdcall; external 'delib.dll'

// ----------------------------------------------------------------------------
// Temperature Inputs
function    DapiTempGet(handle:Longint; ch:Longint): single; stdcall; external 'delib.dll'

// ----------------------------------------------------------------------------
// Counter48 Inputs
procedure   DapiCnt48ModeSet(handle:Longint; ch:longint; mode:Longint); stdcall; external 'delib.dll'
function    DapiCnt48ModeGet(handle:Longint; ch:Longint): Longint stdcall; external 'delib.dll'
function    DapiCnt48CounterGet32(handle:Longint; ch:Longint): Longint; stdcall; external 'delib.dll'
// left out (not possible): DapiCnt48CounterGet48

// ----------------------------------------------------------------------------
// Pulse-Generator Outputs
procedure   DapiPulseGenSet(handle:Longint; ch:Longint; mode:Longint; par0:Longint; par1:Longint; par2:Longint); stdcall; external 'delib.dll'

// ----------------------------------------------------------------------------
// PWM Outputs
procedure   DapiPWMOutSet(handle:Longint; ch:Longint; data:single); external 'delib.dll'
function    DapiPWMOutReadback(handle32:longint; ch:longint): single; stdcall; external 'delib.dll'

// ----------------------------------------------------------------------------
// Stepper
function    DapiStepperCommand(handle:Longint; motor:Longint; cmd: Longint; par1: LongInt; par2: LongInt; par3: LongInt; par4: LongInt): Longint; stdcall; external 'delib.dll'
function    DapiStepperCommandEx(handle:Longint; motor:Longint; cmd: Longint; par1: LongInt; par2: LongInt; par3: LongInt; par4: LongInt; par5: Longint; par6: Longint; par7: Longint): Longint; stdcall; external 'delib.dll'
function    DapiStepperGetStatus(handle:Longint; motor:Longint; cmd: Longint): Longint; stdcall; external 'delib.dll'

// ----------------------------------------------------------------------------
// Watchdog
procedure   DapiWatchdogEnable(handle:Longint); stdcall; external 'delib.dll'
procedure   DapiWatchdogDisable(handle:Longint); stdcall; external 'delib.dll'
procedure   DapiWatchdogRetrigger(handle:Longint); stdcall; external 'delib.dll'

// ----------------------------------------------------------------------------
// Fifo
// left out (not possible) DapiReadFifo
// left out (not possible) DapiWriteFifo

// ----------------------------------------------------------------------------
// CAN
// left out (not possible) type DAPI_CAN_MESSAGE_STRUCT

function    DapiCANCommand(handle:Longint; cmd:Longint; par1:Longint; par2:Longint; par3:Longint): Longint; stdcall; external 'delib.dll'
// left out (not possible) DapiCANGetPacket
// left out (not possible) DapiCANSendPacket

// ----------------------------------------------------------------------------
// Special
function    DapiSpecialCommand(handle:Longint; cmd: Longint; par1: LongInt; par2: LongInt; par3: LongInt): Longint; stdcall; external 'delib.dll'
// left out (not possible): DapiSpecialCommandExt

// left out (not possible): DapiReadMultipleBytes
// left out (not possible): DapiWriteMultipleBytes

// ----------------------------------------------------------------------------
// DI - Counter Mode
const
    DAPI_CNT_MODE_READ                                  = $00;
    DAPI_CNT_MODE_READ_WITH_RESET                       = $01;
    DAPI_CNT_MODE_READ_LATCHED                          = $02;


// ----------------------------------------------------------------------------
// A/D and D/A Modes
const
    DAPI_ADDA_MODE_16BIT_UNIPOL_10V                     = $00;
    DAPI_ADDA_MODE_16BIT_UNIPOL_5V                      = $01;
    DAPI_ADDA_MODE_16BIT_UNIPOL_2V5                     = $02;
    DAPI_ADDA_MODE_18BIT_UNIPOL_10V                     = $03;
    DAPI_ADDA_MODE_16BIT_BIPOL_10V                      = $40;
    DAPI_ADDA_MODE_16BIT_BIPOL_5V                       = $41;
    DAPI_ADDA_MODE_16BIT_BIPOL_2V5                      = $42;
    DAPI_ADDA_MODE_18BIT_BIPOL_10V                      = $43;
    DAPI_ADDA_MODE_16BIT_0_20mA                         = $80;
    DAPI_ADDA_MODE_16BIT_4_20mA                         = $81;
    DAPI_ADDA_MODE_16BIT_0_24mA                         = $82;
//  DAPI_ADDA_MODE_0_25mA                               = $83;
    DAPI_ADDA_MODE_16BIT_0_50mA                         = $84;
    DAPI_ADDA_MODE_18BIT_0_50mA                         = $85;

    DAPI_ADDA_MODE_18BIT_0_20mA_TESTMODE                = $fb;
    DAPI_ADDA_MODE_18BIT_BIPOL_10V_TESTMODE             = $fc;

    DAPI_ADDA_MODE_16BIT_BI_CAL_MODE                    = $fd;
    DAPI_ADDA_MODE_16BIT_0_20mA_TESTMODE                = $fe;
    DAPI_ADDA_MODE_16BIT_BIPOL_10V_TESTMODE             = $ff;

    DAPI_ADDA_MODE_PREVENT_DAPI_MODE_ERROR              = $8000;

// --------------------------------------------------------
// A/D and D/A units
const
    DAPI_ADDA_UNIT_ILLEGAL                              = $00;
    DAPI_ADDA_UNIT_VOLT                                 = $01;
    DAPI_ADDA_UNIT_MA                                   = $02;
    
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// Stepper-Defines

// ------------------------------------
// ERROR Codes
const
    DAPI_STEPPER_ERR_NONE                               = 0;        // No error
    DAPI_STEPPER_ERR_PARAMETER                          = 1;        // Invalid value range
    DAPI_STEPPER_ERR_MOTOR_MOVE                         = 2;        // Motor is currently moving
    DAPI_STEPPER_ERR_DISABLE_MOVE                       = 3;        // Moving motor is disabled
    DAPI_STEPPER_ERR_DEVICE_NOT_FOUND                   = -1;       // No device

// ------------------------------------
// Special Stepper Function-Codes
const
    DAPI_STEPPER_RETURN_0_BYTES                         = $00000000;        // command returns 0 byte
    DAPI_STEPPER_RETURN_1_BYTES                         = $40000000;        // command returns 1 byte
    DAPI_STEPPER_RETURN_2_BYTES                         = $80000000;        // command returns 2 byte
    DAPI_STEPPER_RETURN_4_BYTES                         = $c0000000;        // command returns 4 byte

const
    DAPI_STEPPER_CMD_SET_MOTORCHARACTERISTIC            = $00000001 + DAPI_STEPPER_RETURN_0_BYTES;
    DAPI_STEPPER_CMD_GET_MOTORCHARACTERISTIC            = $00000002 + DAPI_STEPPER_RETURN_4_BYTES;
    DAPI_STEPPER_CMD_SET_POSITION                       = $00000003 + DAPI_STEPPER_RETURN_0_BYTES;
    DAPI_STEPPER_CMD_GO_POSITION                        = $00000004 + DAPI_STEPPER_RETURN_0_BYTES;
    DAPI_STEPPER_CMD_GET_POSITION                       = $00000005 + DAPI_STEPPER_RETURN_4_BYTES;
    DAPI_STEPPER_CMD_SET_FREQUENCY                      = $00000006 + DAPI_STEPPER_RETURN_0_BYTES;
    DAPI_STEPPER_CMD_SET_FREQUENCY_DIRECTLY             = $00000007 + DAPI_STEPPER_RETURN_0_BYTES;
    DAPI_STEPPER_CMD_GET_FREQUENCY                      = $00000008 + DAPI_STEPPER_RETURN_2_BYTES;
    DAPI_STEPPER_CMD_FULLSTOP                           = $00000009 + DAPI_STEPPER_RETURN_0_BYTES;
    DAPI_STEPPER_CMD_STOP                               = $00000010 + DAPI_STEPPER_RETURN_0_BYTES;
    DAPI_STEPPER_CMD_GO_REFSWITCH                       = $00000011 + DAPI_STEPPER_RETURN_0_BYTES;
    DAPI_STEPPER_CMD_DISABLE                            = $00000014 + DAPI_STEPPER_RETURN_0_BYTES;
    DAPI_STEPPER_CMD_MOTORCHARACTERISTIC_LOAD_DEFAULT   = $00000015 + DAPI_STEPPER_RETURN_0_BYTES;
    DAPI_STEPPER_CMD_MOTORCHARACTERISTIC_EEPROM_SAVE    = $00000016 + DAPI_STEPPER_RETURN_0_BYTES;
    DAPI_STEPPER_CMD_MOTORCHARACTERISTIC_EEPROM_LOAD    = $00000017 + DAPI_STEPPER_RETURN_0_BYTES;
    DAPI_STEPPER_CMD_GET_CPU_TEMP                       = $00000018 + DAPI_STEPPER_RETURN_1_BYTES;
    DAPI_STEPPER_CMD_GET_MOTOR_SUPPLY_VOLTAGE           = $00000019 + DAPI_STEPPER_RETURN_2_BYTES;
    DAPI_STEPPER_CMD_GO_POSITION_RELATIVE               = $00000020 + DAPI_STEPPER_RETURN_0_BYTES;
    DAPI_STEPPER_CMD_EEPROM_ERASE                       = $00000021 + DAPI_STEPPER_RETURN_0_BYTES;  
    DAPI_STEPPER_CMD_SET_VECTORMODE                     = $00000040 + DAPI_STEPPER_RETURN_0_BYTES;

// ------------------------------------
// values for PAR1 for DAPI_STEPPER_CMD_SET_MOTORCHARACTERISTIC
const
    DAPI_STEPPER_MOTORCHAR_PAR_STEPMODE                             = 1;                    // Stepmode (full-, half-, quarter-, eighth- or sixteenth stop mode)
    DAPI_STEPPER_MOTORCHAR_PAR_GOFREQUENCY                          = 2;                    // Step frequency for GoPosition [fullstep / s]
    DAPI_STEPPER_MOTORCHAR_PAR_STARTFREQUENCY                       = 3;                    // Start frequency [fullstep / s]
    DAPI_STEPPER_MOTORCHAR_PAR_STOPFREQUENCY                        = 4;                    // Stop frequency [fullstep / s]
    DAPI_STEPPER_MOTORCHAR_PAR_MAXFREQUENCY                         = 5;                    // Max. frequency [fullstep / s]
    DAPI_STEPPER_MOTORCHAR_PAR_ACCELERATIONSLOPE                    = 6;                    // Acceleration slope [fullstep / ms] - (maximum value=1000)
    DAPI_STEPPER_MOTORCHAR_PAR_DECELERATIONSLOPE                    = 7;                    // Deceleration slope [fullstep / ms] - (maximum value=1000)
    DAPI_STEPPER_MOTORCHAR_PAR_PHASECURRENT                         = 8;                    // Phase current [mA] - (maximum value=1500)
    DAPI_STEPPER_MOTORCHAR_PAR_HOLDPHASECURRENT                     = 9;                    // Phase current at motor hold [mA] - (maximum value=1500)
    DAPI_STEPPER_MOTORCHAR_PAR_HOLDTIME                             = 10;                   // Time in that the hold goes to motorstop [ms]
    DAPI_STEPPER_MOTORCHAR_PAR_STATUSLEDMODE                        = 11;                   // Mode of the Status-LED
    DAPI_STEPPER_MOTORCHAR_PAR_INVERT_ENDSW1                        = 12;                   // Invert end-switch 1
    DAPI_STEPPER_MOTORCHAR_PAR_INVERT_ENDSW2                        = 13;                   // Invert end-switch 2
    DAPI_STEPPER_MOTORCHAR_PAR_INVERT_REFSW1                        = 14;                   // Invert ref-switch 1
    DAPI_STEPPER_MOTORCHAR_PAR_INVERT_REFSW2                        = 15;                   // Invert ref-switch 2
    DAPI_STEPPER_MOTORCHAR_PAR_INVERT_DIRECTION                     = 16;                   // Invert direction
    DAPI_STEPPER_MOTORCHAR_PAR_ENDSWITCH_STOPMODE                   = 17;                   // Setting of the stop behaviour (0=Fullstop / 1=Stop)
    DAPI_STEPPER_MOTORCHAR_PAR_GOREFERENCEFREQUENCY_TOENDSWITCH     = 18;                   // Motor Frequency for GoReferenceCommand
    DAPI_STEPPER_MOTORCHAR_PAR_GOREFERENCEFREQUENCY_AFTERENDSWITCH  = 19;                   // Motor Frequency for GoReferenceCommand
    DAPI_STEPPER_MOTORCHAR_PAR_GOREFERENCEFREQUENCY_TOOFFSET        = 20;                   // Motor Frequency for GoReferenceCommand

// ----------------------------------------------------------------------------
// values for PAR1 for DAPI_STEPPER_CMD_GO_REFSWITCH

const
     DAPI_STEPPER_GO_REFSWITCH_PAR_REF1                             = 1;
     DAPI_STEPPER_GO_REFSWITCH_PAR_REF2                             = 2;
     DAPI_STEPPER_GO_REFSWITCH_PAR_REF_LEFT                         = 4;
     DAPI_STEPPER_GO_REFSWITCH_PAR_REF_RIGHT                        = 8;
     DAPI_STEPPER_GO_REFSWITCH_PAR_REF_GO_POSITIVE                  = 16;
     DAPI_STEPPER_GO_REFSWITCH_PAR_REF_GO_NEGATIVE                  = 32;
     DAPI_STEPPER_GO_REFSWITCH_PAR_SET_POS_0                        = 64;

// ------------------------------------
// Stepper Read Status
const
    DAPI_STEPPER_STATUS_GET_POSITION                                = $01;
    DAPI_STEPPER_STATUS_GET_SWITCH                                  = $02;
    DAPI_STEPPER_STATUS_GET_ACTIVITY                                = $03;


// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// CAN-Defines

// ------------------------------------
// CAN Commands
const
    DAPI_CAN_CMD_SET_BITRATE                                    = 1;
    DAPI_CAN_CMD_SET_MASK0                                      = 2;
    DAPI_CAN_CMD_SET_RX_ADDRESS                                 = 3;
    DAPI_CAN_CMD_CLR_TIMESTAMP                                  = 4;
    DAPI_CAN_CMD_GET_BITRATE                                    = 5;
    DAPI_CAN_CMD_GET_TIMESTAMP                                  = 6;

    DAPI_CAN_CMD_TEST_GEN_RX_PACK                               = $fffffff0;


    DAPI_PAR_CAN_MESSAGE_BOX_0                                  = 0;
    DAPI_PAR_CAN_MESSAGE_BOX_1                                  = 1;
    DAPI_PAR_CAN_MESSAGE_BOX_2                                  = 2;
    DAPI_PAR_CAN_MESSAGE_BOX_3                                  = 3;

    DAPI_CAN_BITRATE_10000                                      = 10000;
    DAPI_CAN_BITRATE_20000                                      = 20000;
    DAPI_CAN_BITRATE_50000                                      = 50000;
    DAPI_CAN_BITRATE_100000                                     = 100000;
    DAPI_CAN_BITRATE_125000                                     = 125000;
    DAPI_CAN_BITRATE_250000                                     = 250000;
    DAPI_CAN_BITRATE_500000                                     = 500000;
	DAPI_CAN_BITRATE_800000                                     = 800000;
    DAPI_CAN_BITRATE_1000000                                    = 1000000;

    DAPI_CAN_MASK_SINGLE                                        = $ffffffff;
    DAPI_CAN_MASK_ALL                                           = $0;

// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// CNT48 Commands

    DAPI_CNT48_FILTER_20ns                                      = $0000;
    DAPI_CNT48_FILTER_100ns                                     = $1000;
    DAPI_CNT48_FILTER_250ns                                     = $2000;
    DAPI_CNT48_FILTER_500ns                                     = $3000;
    DAPI_CNT48_FILTER_1us                                       = $4000;
    DAPI_CNT48_FILTER_2_5us                                     = $5000;
    DAPI_CNT48_FILTER_5us                                       = $6000;
    DAPI_CNT48_FILTER_10us                                      = $7000;
    DAPI_CNT48_FILTER_25us                                      = $8000;
    DAPI_CNT48_FILTER_50us                                      = $9000;
    DAPI_CNT48_FILTER_100us                                     = $A000;
    DAPI_CNT48_FILTER_250us                                     = $B000;
    DAPI_CNT48_FILTER_500us                                     = $C000;
    DAPI_CNT48_FILTER_1ms                                       = $D000;
    DAPI_CNT48_FILTER_2_5ms                                     = $E000;
    DAPI_CNT48_FILTER_5ms                                       = $F000;

    DAPI_CNT48_MODE_COUNT_RISING_EDGE                           = $0000;
    DAPI_CNT48_MODE_COUNT_RISING_EDGE_X2                        = $0001;
    DAPI_CNT48_MODE_COUNT_RISING_EDGE_X4                        = $0002;
    DAPI_CNT48_MODE_T                                           = $000D;
    DAPI_CNT48_MODE_FREQUENCY                                   = $000E;
    DAPI_CNT48_MODE_PWM                                         = $000F;

    DAPI_CNT48_SUBMODE_NO_RESET                                 = $0000;
    DAPI_CNT48_SUBMODE_RESET_WITH_READ                          = $0010;
    DAPI_CNT48_SUBMODE_NO_RESET_NO_HW_RESET                     = $0020;
    DAPI_CNT48_SUBMODE_RESET_WITH_READ_NO_HW_RESET              = $0030;
    DAPI_CNT48_SUBMODE_RESET_ON_CH_7                            = $0070;
    DAPI_CNT48_SUBMODE_LATCH_COMMON                             = $0080;
    DAPI_CNT48_SUBMODE_FREQUENCY_TIME_BASE_1ms                  = $0030;
    DAPI_CNT48_SUBMODE_FREQUENCY_TIME_BASE_10ms                 = $0020;
    DAPI_CNT48_SUBMODE_FREQUENCY_TIME_BASE_100ms                = $0010;
    DAPI_CNT48_SUBMODE_FREQUENCY_TIME_BASE_1sec                 = $0000;

// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// Software FIFO Commands

    DAPI_FIFO_TYPE_READ_AD_FIFO                                 = $01;
    
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
const
    DAPI_PWM_FREQUENCY_10HZ                                     = 1;
    DAPI_PWM_FREQUENCY_100HZ                                    = 10;
    DAPI_PWM_FREQUENCY_250HZ                                    = 25;
    DAPI_PWM_FREQUENCY_1000HZ                                   = 100;
    DAPI_PWM_FREQUENCY_SERVO_M1                                 = 254;
// Definitions for DapiOpenEx

// left out (not possible) type DAPI_OPENMODULEEX_STRUCT

    DAPI_OPEN_MODULE_OPTION_USE_EXBUFFER                        = $1;
    DAPI_OPEN_MODULE_OPTION_NO_RESCAN                           = $2;
	DAPI_OPEN_MODULE_OPTION_CANOPENSTICK_NO_REGISTER_REROUTE    = $4;
	
    DAPI_OPEN_MODULE_ENCRYPTION_TYPE_NONE                       = 0;
    DAPI_OPEN_MODULE_ENCRYPTION_TYPE_NORMAL                     = 1;
    DAPI_OPEN_MODULE_ENCRYPTION_TYPE_ADMIN                      = 2;
    DAPI_OPEN_MODULE_ENCRYPTION_TYPE_ADMIN_TEMP                 = 3;

// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
