﻿' ****************************************************************************
' ****************************************************************************
' ****************************************************************************
' ****************************************************************************
' ****************************************************************************
'
'
'
' delib.vb
' project: DELIB
'
'
' (c) DEDITEC GmbH, 2009-2020
' web: http://www.deditec.de/
' mail: vertrieb@deditec.de
'
' 
' ****************************************************************************
' ****************************************************************************
' ****************************************************************************
' ****************************************************************************
' ****************************************************************************
'
Imports System.Runtime.InteropServices


Partial Friend Class DELib

    ' all Module-ID's
    Public Const USB_Interface8                                         = 1
    Public Const USB_CAN_STICK                                          = 2
    Public Const USB_LOGI_500                                           = 3
    Public Const USB_SER_DEBUG                                          = 4
    Public Const RO_SER                                                 = 5
    Public Const USB_BITP_200                                           = 6
    Public Const RO_USB1                                                = 7
    Public Const RO_USB                                                 = 7
    Public Const RO_ETH                                                 = 8
    Public Const USB_MINI_STICK                                         = 9
    Public Const USB_LOGI_18                                            = 10
    Public Const RO_CAN                                                 = 11
    Public Const USB_SPI_MON                                            = 12
    Public Const USB_WATCHDOG                                           = 13
    Public Const USB_OPTOIN_8                                           = 14
    Public Const USB_RELAIS_8                                           = 14
    Public Const USB_OPTOIN_8_RELAIS_8                                  = 15
    Public Const USB_OPTOIN_16_RELAIS_16                                = 16
    Public Const USB_OPTOIN_32                                          = 16
    Public Const USB_RELAIS_32                                          = 16
    Public Const USB_OPTOIN_32_RELAIS_32                                = 17
    Public Const USB_OPTOIN_64                                          = 17
    Public Const USB_RELAIS_64                                          = 17

    Public Const BS_USB_8                                               = 15
    Public Const BS_USB_16                                              = 16
    Public Const BS_USB_32                                              = 17

    Public Const USB_TTL_32                                             = 18
    Public Const USB_TTL_64                                             = 18
    Public Const RO_ETH_INTERN                                          = 19

    Public Const BS_SER                                                 = 20
    Public Const BS_CAN                                                 = 21
    Public Const BS_ETH                                                 = 22

    Public Const NET_ETH                                                = 23

    Public Const RO_CAN2                                                = 24
    Public Const RO_USB2                                                = 25
    Public Const RO_ETH_LC                                              = 26

    Public Const ETH_RELAIS_8                                           = 27
    Public Const ETH_OPTOIN_8                                           = 27
    Public Const ETH_O4_R4_ADDA                                         = 28

    Public Const ETHERNET_MODULE                                        = 29
    
    Public Const ETH_TTL_64                                             = 30

    Public Const NET_USB2                                               = 31
    Public Const NET_ETH_LC                                             = 32
    Public Const NET_USB1                                               = 33
    Public Const NET_SER                                                = 34
    Public Const NET_CAN_OPEN                                           = 35
    Public Const NET_RAS_PI                                             = 36

    Public Const USB_CANOPEN_STICK                                      = 37

    Public Const ETH_CUST_0                                             = 38
	
    Public Const WEU_RELAIS_8                                           = 39
    Public Const WEU_OPTO_8                                             = 39
    Public Const WEU_E_RELAIS_8                                         = 40

    Public Const BS_WEU                                             	= 41
    Public Const BS_WEU_E                                      		= 42
    
    ' ----------------------------------------------------------------------------
    ' ----------------------------------------------------------------------------
    ' ----------------------------------------------------------------------------
    ' ----------------------------------------------------------------------------
    ' ----------------------------------------------------------------------------
    ' Declarations

    ' ----------------------------------------------------------------------------
    ' Special Function-Codes
    Public Const DAPI_SPECIAL_CMD_GET_MODULE_CONFIG                     = &H01
    Public Const DAPI_SPECIAL_CMD_TIMEOUT                               = &H02
    Public Const DAPI_SPECIAL_CMD_DI                                    = &H0a
    Public Const DAPI_SPECIAL_CMD_SET_DIR_DX_1                          = &H03
    Public Const DAPI_SPECIAL_CMD_SET_DIR_DX_8                          = &H04
    Public Const DAPI_SPECIAL_CMD_GET_MODULE_VERSION                    = &H05
    Public Const DAPI_SPECIAL_CMD_DA                                    = &H06 
    Public Const DAPI_SPECIAL_CMD_WATCHDOG                              = &H07
    Public Const DAPI_SPECIAL_CMD_COUNTER                               = &H08
    Public Const DAPI_SPECIAL_CMD_AD                                    = &H09
    Public Const DAPI_SPECIAL_CMD_CNT48                                 = &H0b
    Public Const DAPI_SPECIAL_CMD_SW_FIFO                 	        = &H0c
    Public Const DAPI_SPECIAL_CMD_MODULE_REBOOT                         = &H0d
    Public Const DAPI_SPECIAL_CMD_MODULE_RESCAN                         = &H0e
    Public Const DAPI_SPECIAL_CMD_RESTART_CHECK_MODULE_CONFIG           = &H0f
    Public Const DAPI_SPECIAL_CMD_PWM                                   = &H13
    Public Const DAPI_SPECIAL_CMD_GET_DIR_DX_1                          = &H14 
    Public Const DAPI_SPECIAL_CMD_GET_DIR_DX_8                          = &H15
    Public Const DAPI_SPECIAL_CMD_CANOPEN_STICK                         = &H16

    ' values for PAR1
    Public Const DAPI_SPECIAL_GET_MODULE_CONFIG_PAR_DI                  = 1
    Public Const DAPI_SPECIAL_GET_MODULE_CONFIG_PAR_DI_FF               = 7
    Public Const DAPI_SPECIAL_GET_MODULE_CONFIG_PAR_DI_COUNTER          = 8
    Public Const DAPI_SPECIAL_GET_MODULE_CONFIG_PAR_DO                  = 2
    Public Const DAPI_SPECIAL_GET_MODULE_CONFIG_PAR_DX                  = 3
    Public Const DAPI_SPECIAL_GET_MODULE_CONFIG_PAR_AD                  = 4
    Public Const DAPI_SPECIAL_GET_MODULE_CONFIG_PAR_DA                  = 5
    Public Const DAPI_SPECIAL_GET_MODULE_CONFIG_PAR_TEMP                = 9
    Public Const DAPI_SPECIAL_GET_MODULE_CONFIG_PAR_STEPPER             = 6
    Public Const DAPI_SPECIAL_GET_MODULE_CONFIG_PAR_CNT48               = 10
    Public Const DAPI_SPECIAL_GET_MODULE_CONFIG_PAR_PULSE_GEN           = 11
    Public Const DAPI_SPECIAL_GET_MODULE_CONFIG_PAR_PWM_OUT             = 12
    Public Const DAPI_SPECIAL_GET_MODULE_CONFIG_PAR_HW_INTERFACE1       = 13
    Public Const DAPI_SPECIAL_GET_MODULE_CONFIG_PAR_SW_FEATURE1         = 14
    Public Const DAPI_SPECIAL_GET_MODULE_CONFIG_PAR_HW_GROUP            = 15
    Public Const DAPI_SPECIAL_GET_MODULE_CONFIG_PAR_SW_CLASS            = 16
    Public Const DAPI_SPECIAL_GET_MODULE_CONFIG_PAR_MODULE_ID           = 17
    ' 
    Public Const DAPI_SPECIAL_GET_MODULE_PAR_VERSION_0                  = 0
    Public Const DAPI_SPECIAL_GET_MODULE_PAR_VERSION_1                  = 1
    Public Const DAPI_SPECIAL_GET_MODULE_PAR_VERSION_2                  = 2
    Public Const DAPI_SPECIAL_GET_MODULE_PAR_VERSION_3                  = 3
    ' 
    Public Const DAPI_SPECIAL_TIMEOUT_SET_VALUE_SEC                     = 1
    Public Const DAPI_SPECIAL_TIMEOUT_ACTIVATE                          = 2
    Public Const DAPI_SPECIAL_TIMEOUT_ACTIVATE_AUTO_REACTIVATE          = 10;
    Public Const DAPI_SPECIAL_TIMEOUT_ACTIVATE_SECURE_OUTPUTS           = 11;
    Public Const DAPI_SPECIAL_TIMEOUT_DEACTIVATE                        = 3
    Public Const DAPI_SPECIAL_TIMEOUT_GET_STATUS                        = 4
    Public Const DAPI_SPECIAL_TIMEOUT_DO_VALUE_LOAD_DEFAULT		= 5
    Public Const DAPI_SPECIAL_TIMEOUT_DO_VALUE_MASK_WR_CLR32		= 6
    Public Const DAPI_SPECIAL_TIMEOUT_DO_VALUE_MASK_RD_CLR32		= 7
    Public Const DAPI_SPECIAL_TIMEOUT_DO_VALUE_MASK_WR_SET32		= 8
    Public Const DAPI_SPECIAL_TIMEOUT_DO_VALUE_MASK_RD_SET32		= 9
    ' 
    Public Const DAPI_SPECIAL_DI_FF_FILTER_VALUE_SET                    = 1
    Public Const DAPI_SPECIAL_DI_FF_FILTER_VALUE_GET                    = 2
    ' 
    Public Const DAPI_SPECIAL_RO_AD_FIFO_ACTIVATE                       = 2
    Public Const DAPI_SPECIAL_RO_AD_FIFO_DEACTIVATE                     = 3
    Public Const DAPI_SPECIAL_RO_AD_FIFO_GET_STATUS                     = 4
    Public Const DAPI_SPECIAL_RO_AD_FIFO_SET_INTERVAL_MS                = 5
    Public Const DAPI_SPECIAL_RO_AD_FIFO_SET_CHANNEL                    = 6
    Public Const DAPI_SPECIAL_RO_AD_FIFO_INIT                           = 7
    '
    Public Const DAPI_SPECIAL_AD_READ_MULTIPLE_AD                       = 1
    Public Const DAPI_SPECIAL_AD_FILTER_SET                             = 8
    Public Const DAPI_SPECIAL_AD_FILTER_GET                             = 9
    '
    Public Const DAPI_SPECIAL_DA_PAR_DA_LOAD_DEFAULT                    = 1
    Public Const DAPI_SPECIAL_DA_PAR_DA_SAVE_EEPROM_CONFIG              = 2
    Public Const DAPI_SPECIAL_DA_PAR_DA_LOAD_EEPROM_CONFIG              = 3
    '
    Public Const DAPI_SPECIAL_WATCHDOG_SET_TIMEOUT_MSEC                 = 1
    Public Const DAPI_SPECIAL_WATCHDOG_GET_TIMEOUT_MSEC                 = 2
    Public Const DAPI_SPECIAL_WATCHDOG_GET_STATUS                       = 3
    Public Const DAPI_SPECIAL_WATCHDOG_GET_WD_COUNTER_MSEC              = 4
    Public Const DAPI_SPECIAL_WATCHDOG_GET_TIMEOUT_RELAIS_COUNTER_MSEC  = 5
    Public Const DAPI_SPECIAL_WATCHDOG_SET_TIMEOUT_REL1_COUNTER_MSEC    = 6     
    Public Const DAPI_SPECIAL_WATCHDOG_SET_TIMEOUT_REL2_COUNTER_MSEC    = 7     
    '
    Public Const DAPI_SPECIAL_COUNTER_LATCH_ALL                         = 1
    Public Const DAPI_SPECIAL_COUNTER_LATCH_ALL_WITH_RESET              = 2
    Public Const DAPI_SPECIAL_COUNTER_PRELOAD_SET			= 3
    Public Const DAPI_SPECIAL_COUNTER_PRELOAD_GET			= 4
    Public Const DAPI_SPECIAL_COUNTER_MODE_SET				= 5
    Public Const DAPI_SPECIAL_COUNTER_MODE_GET				= 6
    Public Const DAPI_SPECIAL_COUNTER_GET				= 7
    '
    Public Const DAPI_SPECIAL_CNT48_RESET_SINGLE                        = 1
    Public Const DAPI_SPECIAL_CNT48_RESET_GROUP8                        = 2
    Public Const DAPI_SPECIAL_CNT48_LATCH_GROUP8                        = 3
    Public Const DAPI_SPECIAL_CNT48_DI_GET1                             = 4
    ' 
    Public Const DAPI_SPECIAL_SW_FIFO_INIT_AND_CLEAR			= 1
    Public Const DAPI_SPECIAL_SW_FIFO_ACTIVATE				= 2
    Public Const DAPI_SPECIAL_SW_FIFO_DEACTIVATE			= 3
    Public Const DAPI_SPECIAL_SW_FIFO_SET_SUBMODULE			= 4
    Public Const DAPI_SPECIAL_SW_FIFO_SET_CHANNEL			= 5
    Public Const DAPI_SPECIAL_SW_FIFO_SET_FREQUENCY_HZ			= 6
    Public Const DAPI_SPECIAL_SW_FIFO_SET_MODE				= 7
    
    Public Const DAPI_SPECIAL_SW_FIFO_GET_STATUS			= &H81		' Bit 7 ist gesetzt bei Lesebefehlen
    Public Const DAPI_SPECIAL_SW_FIFO_GET_BYTES_FREE			= &H82
    Public Const DAPI_SPECIAL_SW_FIFO_GET_ACTIVITY			= &H83
    Public Const DAPI_SPECIAL_SW_FIFO_GET_SUBMODULE			= &H84
    Public Const DAPI_SPECIAL_SW_FIFO_GET_CHANNEL			= &H85
    Public Const DAPI_SPECIAL_SW_FIFO_GET_FREQUENCY_HZ			= &H86
    Public Const DAPI_SPECIAL_SW_FIFO_GET_MODE				= &H87
    Public Const DAPI_SPECIAL_SW_FIFO_GET_BYTES_PER_SAMPLE		= &H88
    '   
    Public Const DAPI_SPECIAL_PWM_FREQ_LOAD_DFAULT                      = 1
    Public Const DAPI_SPECIAL_PWM_FREQ_SAVE_EEPROM                      = 2
    Public Const DAPI_SPECIAL_PWM_FREQ_LOAD_EEPROM                      = 3
    Public Const DAPI_SPECIAL_PWM_FREQ_SET                              = 4
    Public Const DAPI_SPECIAL_PWM_FREQ_READBACK                         = 5
    '
    Public Const DAPI_SPECIAL_CANOPEN_STICK_FLUSH			= 1
    Public Const DAPI_SPECIAL_CANOPEN_STICK_SDO_READ			= 2

    ' ----------------------------------------------------------------------------
    ' values for PAR2
    Public Const DAPI_SPECIAL_AD_CH0_CH15                               = 0
    Public Const DAPI_SPECIAL_AD_CH16_CH31                              = 1
    Public Const DAPI_SPECIAL_AD_CH32_CH47                              = 2
    Public Const DAPI_SPECIAL_AD_CH48_CH63                              = 3

    ' ----------------------------------------------------------------------------
    ' DapiScanModules-Codes
    Public Const DAPI_SCANMODULE_GET_MODULES_AVAILABLE                  = 1

    ' ----------------------------------------------------------------------------
    ' SOFTWARE Features Class
    Public Const DAPI_SW_CLASS_TYPE_OF_MODULE_IDENTIFICATION            = (1<<0)            ' Bit 0
    Public Const DAPI_SW_CLASS_DI_DO_DX_CHANNELS                        = (1<<1)            ' Bit 1
    Public Const DAPI_SW_CLASS_AD_DA_CHANNELS                           = (1<<2)            ' Bit 2

    ' ----------------------------------------------------------------------------
    ' Hardware Group
    Public Const DAPI_HW_GROUP_RO                                       = (1<<0)            ' Bit 0
    Public Const DAPI_HW_GROUP_LOGICANALYZER                            = (1<<1)            ' Bit 1
    Public Const DAPI_HW_GROUP_DI_DO_AD_DA                              = (1<<2)            ' Bit 2
    Public Const DAPI_HW_GROUP_USB                                      = (1<<3)            ' Bit 3
    Public Const DAPI_HW_GROUP_BS                                       = (1<<4)            ' Bit 4
    Public Const DAPI_HW_GROUP_NET                                      = (1<<5)            ' Bit 5
    Public Const DAPI_HW_GROUP_ETH                                      = (1<<6)            ' Bit 6
    Public Const DAPI_HW_GROUP_CUST                                     = (1<<7)            ' Bit 7

    ' --------------------------------------------------------
    ' Software Feature Bits
    Public Const DAPI_SW_FEATURE_BIT_SUPPORTED_BY_FIRMWARE              = &H00000001
    Public Const DAPI_SW_FEATURE_BIT_RO_AD_SOFTWARE_FIFO                = &H00000002
    Public Const DAPI_SW_FEATURE_BIT_SW_FIFO				= &H00000100
    Public Const DAPI_SW_FEATURE_BIT_CFG_DO_CMD_SET_CLR_BIT_32          = &H00000004
    Public Const DAPI_SW_FEATURE_BIT_EEPROM_RN23                        = &H00000008
    Public Const DAPI_SW_FEATURE_BIT_EEPROM_E2_2K                       = &H00000020
    Public Const DAPI_SW_FEATURE_BIT_EEPROM_E2_32K                      = &H00000040
    Public Const DAPI_SW_FEATURE_BIT_EEPROM_FS_SUPPORT                  = &H00000080
    Public Const DAPI_SW_FEATURE_BIT_DX_1_MODE                          = &H00000010
    Public Const DAPI_SW_FEATURE_BIT_AUTO_OUTPUTS_OFF_TIMEOUT           = &H02000000
    Public Const DAPI_SW_FEATURE_BIT_AUTO_OUTPUTS_OFF_TIMEOUT_WITH_MASK	= &H00008000
    Public Const DAPI_SW_FEATURE_BIT_SUPP_INDIVIDUAL_CH_NAMES           = &H00001000
    Public Const DAPI_SW_FEATURE_BIT_DEV_IO_REG_ERR_SUPP                = &H00002000
    Public Const DAPI_SW_FEATURE_BIT_SUPP_SYSTEM_INFO                   = &H00004000

    Public Const DAPI_SW_FEATURE_BIT_CFG_WATCHDOG                       = &H10000000

    Public Const DAPI_SW_FEATURE_BIT_CFG_DI                             = &H20000000
    Public Const DAPI_SW_FEATURE_BIT_CFG_DI_CNT                         = &H40000000
    Public Const DAPI_SW_FEATURE_BIT_CFG_DI_CNT_LATCH                   = &H00080000
    Public Const DAPI_SW_FEATURE_BIT_CFG_DI_FF                          = &H80000000

    Public Const DAPI_SW_FEATURE_BIT_CFG_DO                             = &H01000000
    Public Const DAPI_SW_FEATURE_BIT_CFG_DO_WITH_TIMER                  = &H00040000

    Public Const DAPI_SW_FEATURE_BIT_CFG_PWM_OUT                        = &H04000000

    Public Const DAPI_SW_FEATURE_BIT_CFG_DX                             = &H08000000

    Public Const DAPI_SW_FEATURE_BIT_CFG_DA                             = &H00100000
    Public Const DAPI_SW_FEATURE_BIT_CFG_AD                             = &H00200000

    Public Const DAPI_SW_FEATURE_BIT_CFG_CNT_OUT32                      = &H00400000
    Public Const DAPI_SW_FEATURE_BIT_CFG_CNT_IN48                       = &H00800000

    Public Const DAPI_SW_FEATURE_BIT_CFG_TEMP                           = &H00010000
    Public Const DAPI_SW_FEATURE_BIT_CFG_STEPPER                        = &H00020000

    ' --------------------------------------------------------
    ' Hardware Interface Bits
    Public Const DAPI_HW_INTERFACE_BIT_SUPPORTED_BY_FIRMWARE            = &H00000001
    Public Const DAPI_HW_INTERFACE_BIT_CFG_ETH                          = &H00000002
    Public Const DAPI_HW_INTERFACE_BIT_CFG_CAN                          = &H00000004
    Public Const DAPI_HW_INTERFACE_BIT_CFG_RS232                        = &H00000008
    Public Const DAPI_HW_INTERFACE_BIT_CFG_RS232_RS485                  = &H00000010
    Public Const DAPI_HW_INTERFACE_BIT_CFG_USB1                         = &H00000020
    Public Const DAPI_HW_INTERFACE_BIT_CFG_USB2                         = &H00000040
    Public Const DAPI_HW_INTERFACE_BIT_CFG_CANOPEN			= &H00000080

    Public Const DAPI_HW_INTERFACE_PRODUCT_ID_MASK                      = &HFF000000
    Public Const DAPI_HW_INTERFACE_PRODUCT_ID_RO                        = &H01000000
    Public Const DAPI_HW_INTERFACE_PRODUCT_ID_RO2                       = &H02000000
    Public Const DAPI_HW_INTERFACE_PRODUCT_ID_BS                        = &H03000000
    Public Const DAPI_HW_INTERFACE_PRODUCT_ID_NET                       = &H04000000
    Public Const DAPI_HW_INTERFACE_PRODUCT_ID_NET_IP                    = &H05000000
    Public Const DAPI_HW_INTERFACE_PRODUCT_ID_CANOPEN_STICK		= &H06000000
    
    ' --------------------------------------------------------
    ' TCP Feature Bits
    Public Const DAPI_TCP_FEATURE_BIT_SUPPORTED_BY_FIRMWARE             = &H00000001
    Public Const DAPI_TCP_FEATURE_BIT_SUPP_RTC                          = &H00000002
    Public Const DAPI_TCP_FEATURE_BIT_SUPP_SYSTEM_INFO                  = &H00000004

    ' ----------------------------------------------------------------------------
    ' ----------------------------------------------------------------------------
    ' ----------------------------------------------------------------------------
    ' Prototypes for DELIB-Functions
    ' ----------------------------------------------------------------------------
    ' ----------------------------------------------------------------------------
    ' ----------------------------------------------------------------------------

    ' ----------------------------------------------------------------------------
    ' 
    Public Declare Function DapiOpenModule Lib "DELIB" (ByVal moduleID As UInt32, ByVal nr As UInt32) As UInt32
    Public Declare Function DapiOpenModuleEx Lib "DELIB" (ByVal moduleID As UInt32, ByVal nr As UInt32, ByRef exbuffer As DAPI_OPENMODULEEX_STRUCT, ByVal open_options As UInt32) As UInt32
    Public Declare Function DapiCloseModule Lib "DELIB" (ByVal handle As UInt32) As UInt32

    Public Declare Function DapiScanModule Lib "DELIB" (ByVal moduleID As UInt32, ByVal cmd As UInt32) As UInt32
    Public Declare Function DapiScanAllModulesAvailable Lib "DELIB" (ByVal todo As UInt32) As UInt32
    Public Declare Function DapiScanAllModulesAvailableListEcecute Lib "DELIB" (ByVal nr As Uint32, ByVal todo As Uint32) As Uint32

    Public Declare Function DapiGetDELIBVersion Lib "DELIB" (ByVal mode As UInt32, ByVal par As UInt32) As UInt32

    Public Declare Function DapiPing Lib "DELIB" (ByVal handle As UInt32, ByVal value As UInt32) As UInt32

    ' ----------------------------------------------------------------------------
    ' Register Access
    Public Declare Sub DapiWriteByte Lib "DELIB" (ByVal handle As UInt32, ByVal adress As UInt32, ByVal value As UInt32)
    Public Declare Sub DapiWriteWord Lib "DELIB" (ByVal handle As UInt32, ByVal adress As UInt32, ByVal value As UInt32)
    Public Declare Sub DapiWriteLong Lib "DELIB" (ByVal handle As UInt32, ByVal adress As UInt32, ByVal value As UInt32)
    Public Declare Sub DapiWriteLongLong Lib "DELIB" (ByVal handle As UInt32, ByVal adress As UInt32, ByVal value As UInt64)

    Public Declare Function DapiReadByte Lib "DELIB" (ByVal handle As UInt32, ByVal adress As UInt32) As UInt32
    Public Declare Function DapiReadWord Lib "DELIB" (ByVal handle As UInt32, ByVal adress As UInt32) As UInt32
    Public Declare Function DapiReadLong Lib "DELIB" (ByVal handle As UInt32, ByVal adress As UInt32) As UInt32
    Public Declare Function DapiReadLongLong Lib "DELIB" (ByVal handle As UInt32, ByVal adress As UInt32) As UInt64

    ' ----------------------------------------------------------------------------
    ' Error Handling
    Public Declare Function DapiGetLastError Lib "DELIB" () As UInt32
    Public Declare Function DapiGetLastErrorText Lib "DELIB" (ByVal msg As System.Text.StringBuilder, ByVal msg_length As UInt32) As UInt32
    Public Declare Sub DapiClearLastError Lib "DELIB" ()

    Public Declare Function DapiGetLastErrorByHandle Lib "DELIB" (ByVal handle As UInt32) As UInt32
    Public Declare Sub DapiClearLastErrorByHandle Lib "DELIB" (ByVal handle As UInt32)

    ' ----------------------------------------------------------------------------
    ' Digital Inputs
    Public Declare Function DapiDIGet1 Lib "DELIB" (ByVal handle As UInt32, ByVal ch As UInt32) As UInt32
    Public Declare Function DapiDIGet8 Lib "DELIB" (ByVal handle As UInt32, ByVal ch As UInt32) As UInt32
    Public Declare Function DapiDIGet16 Lib "DELIB" (ByVal handle As UInt32, ByVal ch As UInt32) As UInt32
    Public Declare Function DapiDIGet32 Lib "DELIB" (ByVal handle As UInt32, ByVal ch As UInt32) As UInt32
    Public Declare Function DapiDIGet64 Lib "DELIB" (ByVal handle As UInt32, ByVal ch As UInt32) As UInt64

    Public Declare Function DapiDIGetFF32 Lib "DELIB" (ByVal handle As UInt32, ByVal ch As UInt32) As UInt32

    Public Declare Function DapiDIGetCounter Lib "DELIB" (ByVal handle As UInt32, ByVal ch As UInt32, ByVal mode As UInt32) As UInt32

    ' ----------------------------------------------------------------------------
    ' Digital Outputs
    Public Declare Sub DapiDOSet1 Lib "DELIB" (ByVal handle As UInt32, ByVal ch As UInt32, ByVal data As UInt32)
    Public Declare Sub DapiDOSet8 Lib "DELIB" (ByVal handle As UInt32, ByVal ch As UInt32, ByVal data As UInt32)
    Public Declare Sub DapiDOSet16 Lib "DELIB" (ByVal handle As UInt32, ByVal ch As UInt32, ByVal data As UInt32)
    Public Declare Sub DapiDOSet32 Lib "DELIB" (ByVal handle As UInt32, ByVal ch As UInt32, ByVal data As UInt32)
    Public Declare Sub DapiDOSet64 Lib "DELIB" (ByVal handle As UInt32, ByVal ch As UInt32, ByVal data As UInt64)

    Public Declare Function DapiDOReadback32 Lib "DELIB" (ByVal handle As UInt32, ByVal ch As UInt32) As UInt32
    Public Declare Function DapiDOReadback64 Lib "DELIB" (ByVal handle As UInt32, ByVal ch As UInt32) As UInt64

    Public Declare Sub DapiDOSet1_WithTimer Lib "DELIB" (ByVal handle As UInt32, ByVal ch As UInt32, ByVal data As UInt32, ByVal time_ms As UInt32)
    Public Declare Sub DapiDOSetBit32 Lib "DELIB" (ByVal handle As UInt32, ByVal ch As UInt32, ByVal data As UInt32)
    Public Declare Sub DapiDOClrBit32 Lib "DELIB" (ByVal handle As UInt32, ByVal ch As UInt32, ByVal data As UInt32)

    ' ----------------------------------------------------------------------------
    ' Analog Inputs
    Public Declare Function DapiADGet Lib "DELIB" (ByVal handle As UInt32, ByVal ch As UInt32) As UInt32
    Public Declare Function DapiADGetValueModeUnit Lib "DELIB" (ByVal handle As UInt32, ByVal ch As UInt32, ByRef mode As UInt32, ByRef unit As UInt32) As Single
    Public Declare Function DapiADGetVolt Lib "DELIB" (ByVal handle As UInt32, ByVal ch As UInt32) As Single
    Public Declare Function DapiADGetmA Lib "DELIB" (ByVal handle As UInt32, ByVal ch As UInt32) As Single
    Public Declare Sub DapiADSetMode Lib "DELIB" (ByVal handle As UInt32, ByVal ch As UInt32, ByVal mode As UInt32)
    Public Declare Function DapiADGetMode Lib "DELIB" (ByVal handle As UInt32, ByVal ch As UInt32) As UInt32

    ' ----------------------------------------------------------------------------
    ' Analog Outputs
    Public Declare Sub DapiDASet Lib "DELIB" (ByVal handle As UInt32, ByVal ch As UInt32, ByVal data As UInt32)
    Public Declare Sub DapiDASetVolt Lib "DELIB" (ByVal handle As UInt32, ByVal ch As UInt32, ByVal data As Single)
    Public Declare Sub DapiDASetmA Lib "DELIB" (ByVal handle As UInt32, ByVal ch As UInt32, ByVal data As UInt32)
    Public Declare Function DapiDAGetValueModeUnit Lib "DELIB" (ByVal handle As UInt32, ByVal ch As UInt32, ByRef mode As UInt32, ByRef unit As UInt32) As Single
    Public Declare Sub DapiDASetMode Lib "DELIB" (ByVal handle As UInt32, ByVal ch As UInt32, ByVal mode As UInt32)
    Public Declare Function DapiDAGetMode Lib "DELIB" (ByVal handle As UInt32, ByVal ch As UInt32) As UInt32

    ' ----------------------------------------------------------------------------
    ' Temperature Inputs
    Public Declare Function DapiTempGet Lib "DELIB" (ByVal handle As UInt32, ByVal ch As UInt32) As Single

    ' ----------------------------------------------------------------------------
    ' Counter48 Inputs
    Public Declare Sub DapiCnt48ModeSet Lib "DELIB" (ByVal handle As UInt32, ByVal ch As UInt32, ByVal mode As UInt32)
    Public Declare Function DapiCnt48ModeGet Lib "DELIB" (ByVal handle As UInt32, ByVal ch As UInt32) As UInt32
    Public Declare Function DapiCnt48CounterGet32 Lib "DELIB" (ByVal handle As UInt32, ByVal ch As UInt32) As UInt32
    Public Declare Function DapiCnt48CounterGet48 Lib "DELIB" (ByVal handle As UInt32, ByVal ch As UInt32) As UInt64

    ' ----------------------------------------------------------------------------
    ' Pulse-Generator Outputs
    Public Declare Sub DapiPulseGenSet Lib "DELIB" (ByVal handle As UInt32, ByVal ch As UInt32, ByVal mode As UInt32, ByVal par0 As UInt32, ByVal par1 As UInt32, ByVal par2 As UInt32)

    ' ----------------------------------------------------------------------------
    ' PWM Outputs
    Public Declare Sub DapiPWMOutSet Lib "DELIB" (ByVal handle As UInt32, ByVal ch As UInt32, ByVal data As Single)
    Public Declare Function DapiPWMOutReadback Lib "DELIB" (ByVal handle32 As UInt32, ByVal ch As UInt32) As Single

    ' ----------------------------------------------------------------------------
    ' Stepper
    Public Declare Function DapiStepperCommand Lib "DELIB" (ByVal handle As UInt32, ByVal motor As UInt32, ByVal cmd As UInt32, ByVal par1 As UInt32, ByVal par2 As UInt32, ByVal par3 As UInt32, ByVal par4 As UInt32) As UInt32
    Public Declare Function DapiStepperCommandEx Lib "DELIB" (ByVal handle As UInt32, ByVal motor As UInt32, ByVal cmd As UInt32, ByVal par1 As UInt32, ByVal par2 As UInt32, ByVal par3 As UInt32, ByVal par4 As UInt32, ByVal par5 As UInt32, ByVal par6 As UInt32, ByVal par7 As UInt32) As UInt32
    Public Declare Function DapiStepperGetStatus Lib "DELIB" (ByVal handle As UInt32, ByVal motor As UInt32, ByVal cmd As UInt32) As UInt32

    ' ----------------------------------------------------------------------------
    ' Watchdog
    Public Declare Sub DapiWatchdogEnable Lib "DELIB" (ByVal handle As UInt32)
    Public Declare Sub DapiWatchdogDisable Lib "DELIB" (ByVal handle As UInt32)
    Public Declare Sub DapiWatchdogRetrigger Lib "DELIB" (ByVal handle As UInt32)

    ' --------------------------------------------------------
    ' Fifo
    Public Declare Function DapiReadFifo  Lib "DELIB" (ByVal handle As UInt32, ByVal fifo_instance As UInt32, ByVal type As UInt32, ByRef buff As Byte, ByVal buff_len As UInt32) As UInt32
    Public Declare Function DapiWriteFifo Lib "DELIB" (ByVal handle As UInt32, ByVal fifo_instance As UInt32, ByVal type As UInt32, ByRef buff As Byte, ByVal buff_len As UInt32) As UInt32

    ' ----------------------------------------------------------------------------
    ' CAN
    <StructLayout(LayoutKind.Sequential, Pack:=1)> _
    Friend Structure DAPI_CAN_MESSAGE_STRUCT
        Dim address As UInt32
        Dim timestamp As UInt32
        Dim use_extended_ids As UInt32
        Dim rtr As UInt32
        Dim data_count As UInt32
        <MarshalAs(UnmanagedType.ByValArray, SizeConst:=8)> Dim data() As Byte
    End Structure

    Public Declare Function DapiCANCommand Lib "DELIB" (ByVal handle As UInt32, ByVal cmd As UInt32, ByVal par1 As UInt32, ByVal par2 As UInt32, ByVal par3 As UInt32) As UInt32
    Public Declare Function DapiCANGetPacket Lib "DELIB" (ByVal handle As UInt32, ByVal message_box_nr As UInt32, ByRef can_msg As DAPI_CAN_MESSAGE_STRUCT) As UInt32
    Public Declare Sub DapiCANSendPacket Lib "DELIB" (ByVal handle As UInt32, ByRef can_msg As DAPI_CAN_MESSAGE_STRUCT)

    ' ----------------------------------------------------------------------------
    ' Special
    Public Declare Function DapiSpecialCommand Lib "DELIB" (ByVal handle As UInt32, ByVal cmd As UInt32, ByVal par1 As UInt32, ByVal par2 As UInt32, ByVal par3 As UInt32) As UInt32
    Public Declare Function DapiSpecialCommandExt Lib "DELIB" (ByVal handle As UInt32, ByVal cmd As UInt32, ByVal par1 As UInt32, ByVal par2 As UInt32, ByVal par3 As UInt32, ByRef par4 As UInt32, ByRef par5 As UInt32, ByRef par6 As UInt32, ByRef buff1 As Byte, ByVal buff1_size As UInt32, ByRef buff2 As Byte, ByVal buff2_size As UInt32, ByRef buff3 As Byte, ByVal buff3_size As UInt32, ByRef buff3_length As UInt32) As UInt32

    Public Declare Function DapiReadMultipleBytes Lib "DELIB" (ByVal handle As UInt32, ByVal adress As UInt32, ByVal adress_depth As UInt32, ByVal increments As UInt32, ByRef buff As Byte, ByVal buff_len As UInt32) As UInt32
    Public Declare Function DapiWriteMultipleBytes Lib "DELIB" (ByVal handle As UInt32, ByVal adress As UInt32, ByVal adress_depth As UInt32, ByVal increments As UInt32, ByRef buff As Byte, ByVal buff_len As UInt32) As UInt32

    ' ----------------------------------------------------------------------------
    ' DI - Counter Mode
    Public Const DAPI_CNT_MODE_READ                                             = &H00
    Public Const DAPI_CNT_MODE_READ_WITH_RESET                                  = &H01
    Public Const DAPI_CNT_MODE_READ_LATCHED                                     = &H02

    ' ----------------------------------------------------------------------------
    ' A/D and D/A Modes
    Public Const DAPI_ADDA_MODE_16BIT_UNIPOL_10V                                = &H00
    Public Const DAPI_ADDA_MODE_16BIT_UNIPOL_5V                                 = &H01
    Public Const DAPI_ADDA_MODE_16BIT_UNIPOL_2V5                                = &H02
    Public Const DAPI_ADDA_MODE_18BIT_UNIPOL_10V                                = &H03

    Public Const DAPI_ADDA_MODE_16BIT_BIPOL_10V                                 = &H40
    Public Const DAPI_ADDA_MODE_16BIT_BIPOL_5V                                  = &H41
    Public Const DAPI_ADDA_MODE_16BIT_BIPOL_2V5                                 = &H42
    Public Const DAPI_ADDA_MODE_18BIT_BIPOL_10V                                 = &H43

    Public Const DAPI_ADDA_MODE_16BIT_0_20mA                                    = &H80
    Public Const DAPI_ADDA_MODE_16BIT_4_20mA                                    = &H81
    Public Const DAPI_ADDA_MODE_16BIT_0_24mA                                    = &H82
    'Public Const DAPI_ADDA_MODE_0_25mA                                         = &H83
    Public Const DAPI_ADDA_MODE_16BIT_0_50mA                                    = &H84
    Public Const DAPI_ADDA_MODE_18BIT_0_50mA                                    = &H85

    Public Const  DAPI_ADDA_MODE_18BIT_0_20mA_TESTMODE                          = &Hfb
    Public Const  DAPI_ADDA_MODE_18BIT_BIPOL_10V_TESTMODE                       = &Hfc

    Public Const DAPI_ADDA_MODE_16BIT_BI_CAL_MODE                               = &Hfd
    Public Const DAPI_ADDA_MODE_16BIT_0_20mA_TESTMODE                           = &Hfe
    Public Const DAPI_ADDA_MODE_16BIT_BIPOL_10V_TESTMODE                        = &Hff

    Public Const DAPI_ADDA_MODE_PREVENT_DAPI_MODE_ERROR                         = &H8000

    ' ----------------------------------------------------------------------------
    ' A/D and D/A units
    Public Const DAPI_ADDA_UNIT_ILLEGAL                                         = &H00
    Public Const DAPI_ADDA_UNIT_VOLT                                            = &H01
    Public Const DAPI_ADDA_UNIT_MA                                              = &H02

    ' ----------------------------------------------------------------------------
    ' ----------------------------------------------------------------------------
    ' ----------------------------------------------------------------------------
    ' ----------------------------------------------------------------------------
    ' ----------------------------------------------------------------------------
    ' Stepper-Defines

    ' ----------------------------------------------------------------------------
    ' ERROR Codes
    Public Const DAPI_STEPPER_ERR_NONE                                          = 0     ' No error
    Public Const DAPI_STEPPER_ERR_PARAMETER                                     = 1     ' Invalid value range
    Public Const DAPI_STEPPER_ERR_MOTOR_MOVE                                    = 2     ' Motor is currently moving
    Public Const DAPI_STEPPER_ERR_DISABLE_MOVE                                  = 3     ' Moving motor is disabled
    Public Const DAPI_STEPPER_ERR_DEVICE_NOT_FOUND                              = -1    ' No device

    ' ----------------------------------------------------------------------------
    ' Special Stepper Function-Codes
    Public Const DAPI_STEPPER_RETURN_0_BYTES                                    = &H00000000    ' command returns 0 byte
    Public Const DAPI_STEPPER_RETURN_1_BYTES                                    = &H40000000    ' command returns 1 byte
    Public Const DAPI_STEPPER_RETURN_2_BYTES                                    = &H80000000    ' command returns 2 byte
    Public Const DAPI_STEPPER_RETURN_4_BYTES                                    = &Hc0000000    ' command returns 4 byte

    Public Const DAPI_STEPPER_CMD_SET_MOTORCHARACTERISTIC                       = (&H00000001 + DAPI_STEPPER_RETURN_0_BYTES)
    Public Const DAPI_STEPPER_CMD_GET_MOTORCHARACTERISTIC                       = (&H00000002 + DAPI_STEPPER_RETURN_4_BYTES)
    Public Const DAPI_STEPPER_CMD_SET_POSITION                                  = (&H00000003 + DAPI_STEPPER_RETURN_0_BYTES)
    Public Const DAPI_STEPPER_CMD_GO_POSITION                                   = (&H00000004 + DAPI_STEPPER_RETURN_0_BYTES)
    Public Const DAPI_STEPPER_CMD_GET_POSITION                                  = (&H00000005 + DAPI_STEPPER_RETURN_4_BYTES)
    Public Const DAPI_STEPPER_CMD_SET_FREQUENCY                                 = (&H00000006 + DAPI_STEPPER_RETURN_0_BYTES)
    Public Const DAPI_STEPPER_CMD_SET_FREQUENCY_DIRECTLY                        = (&H00000007 + DAPI_STEPPER_RETURN_0_BYTES)
    Public Const DAPI_STEPPER_CMD_GET_FREQUENCY                                 = (&H00000008 + DAPI_STEPPER_RETURN_2_BYTES)
    Public Const DAPI_STEPPER_CMD_FULLSTOP                                      = (&H00000009 + DAPI_STEPPER_RETURN_0_BYTES)
    Public Const DAPI_STEPPER_CMD_STOP                                          = (&H00000010 + DAPI_STEPPER_RETURN_0_BYTES)
    Public Const DAPI_STEPPER_CMD_GO_REFSWITCH                                  = (&H00000011 + DAPI_STEPPER_RETURN_0_BYTES)
    Public Const DAPI_STEPPER_CMD_DISABLE                                       = (&H00000014 + DAPI_STEPPER_RETURN_0_BYTES)
    Public Const DAPI_STEPPER_CMD_MOTORCHARACTERISTIC_LOAD_DEFAULT              = (&H00000015 + DAPI_STEPPER_RETURN_0_BYTES)
    Public Const DAPI_STEPPER_CMD_MOTORCHARACTERISTIC_EEPROM_SAVE               = (&H00000016 + DAPI_STEPPER_RETURN_0_BYTES)
    Public Const DAPI_STEPPER_CMD_MOTORCHARACTERISTIC_EEPROM_LOAD               = (&H00000017 + DAPI_STEPPER_RETURN_0_BYTES)
    Public Const DAPI_STEPPER_CMD_GET_CPU_TEMP                                  = (&H00000018 + DAPI_STEPPER_RETURN_1_BYTES)
    Public Const DAPI_STEPPER_CMD_GET_MOTOR_SUPPLY_VOLTAGE                      = (&H00000019 + DAPI_STEPPER_RETURN_2_BYTES)
    Public Const DAPI_STEPPER_CMD_GO_POSITION_RELATIVE                          = (&H00000020 + DAPI_STEPPER_RETURN_0_BYTES)
    public const DAPI_STEPPER_CMD_EEPROM_ERASE                                  = (&H00000021 + DAPI_STEPPER_RETURN_0_BYTES)
    Public Const DAPI_STEPPER_CMD_SET_VECTORMODE                                = (&H00000040 + DAPI_STEPPER_RETURN_0_BYTES)

    ' ----------------------------------------------------------------------------
    ' values for PAR1 for DAPI_STEPPER_CMD_SET_MOTORCHARACTERISTIC
    Public Const DAPI_STEPPER_MOTORCHAR_PAR_STEPMODE                            = 1     ' Stepmode (full-, half-, quarter-, eighth- or sixteenth stop mode)
    Public Const DAPI_STEPPER_MOTORCHAR_PAR_GOFREQUENCY                         = 2     ' Step frequency for GoPosition [fullstep / s]
    Public Const DAPI_STEPPER_MOTORCHAR_PAR_STARTFREQUENCY                      = 3     ' Start frequency [fullstep / s]
    Public Const DAPI_STEPPER_MOTORCHAR_PAR_STOPFREQUENCY                       = 4     ' Stop frequency [fullstep / s]
    Public Const DAPI_STEPPER_MOTORCHAR_PAR_MAXFREQUENCY                        = 5     ' Max. frequency [fullstep / s]
    Public Const DAPI_STEPPER_MOTORCHAR_PAR_ACCELERATIONSLOPE                   = 6     ' Acceleration slope [fullstep / ms] - (maximum value=1000)
    Public Const DAPI_STEPPER_MOTORCHAR_PAR_DECELERATIONSLOPE                   = 7     ' Deceleration slope [fullstep / ms] - (maximum value=1000)
    Public Const DAPI_STEPPER_MOTORCHAR_PAR_PHASECURRENT                        = 8     ' Phase current [mA] - (maximum value=1500)
    Public Const DAPI_STEPPER_MOTORCHAR_PAR_HOLDPHASECURRENT                    = 9     ' Phase current at motor hold [mA] - (maximum value=1500)
    Public Const DAPI_STEPPER_MOTORCHAR_PAR_HOLDTIME                            = 10    ' Time in that the hold goes to motorstop [ms]
    Public Const DAPI_STEPPER_MOTORCHAR_PAR_STATUSLEDMODE                       = 11    ' Mode of the Status-LED
    Public Const DAPI_STEPPER_MOTORCHAR_PAR_INVERT_ENDSW1                       = 12    ' Invert end-switch 1
    Public Const DAPI_STEPPER_MOTORCHAR_PAR_INVERT_ENDSW2                       = 13    ' Invert end-switch 2
    Public Const DAPI_STEPPER_MOTORCHAR_PAR_INVERT_REFSW1                       = 14    ' Invert ref-switch 1
    Public Const DAPI_STEPPER_MOTORCHAR_PAR_INVERT_REFSW2                       = 15    ' Invert ref-switch 2
    Public Const DAPI_STEPPER_MOTORCHAR_PAR_INVERT_DIRECTION                    = 16    ' Invert direction
    Public Const DAPI_STEPPER_MOTORCHAR_PAR_ENDSWITCH_STOPMODE                  = 17    ' Setting of the stop behaviour (0=Fullstop / 1=Stop)
    Public Const DAPI_STEPPER_MOTORCHAR_PAR_GOREFERENCEFREQUENCY_TOENDSWITCH    = 18    ' Motor Frequency for GoReferenceCommand
    Public Const DAPI_STEPPER_MOTORCHAR_PAR_GOREFERENCEFREQUENCY_AFTERENDSWITCH = 19    ' Motor Frequency for GoReferenceCommand
    Public Const DAPI_STEPPER_MOTORCHAR_PAR_GOREFERENCEFREQUENCY_TOOFFSET       = 20    ' Motor Frequency for GoReferenceCommand

    ' ----------------------------------------------------------------------------
    ' values for PAR1 for DAPI_STEPPER_CMD_GO_REFSWITCH
    Public Const DAPI_STEPPER_GO_REFSWITCH_PAR_REF1                             = 1
    Public Const DAPI_STEPPER_GO_REFSWITCH_PAR_REF2                             = 2
    Public Const DAPI_STEPPER_GO_REFSWITCH_PAR_REF_LEFT                         = 4
    Public Const DAPI_STEPPER_GO_REFSWITCH_PAR_REF_RIGHT                        = 8
    Public Const DAPI_STEPPER_GO_REFSWITCH_PAR_REF_GO_POSITIVE                  = 16
    Public Const DAPI_STEPPER_GO_REFSWITCH_PAR_REF_GO_NEGATIVE                  = 32
    Public Const DAPI_STEPPER_GO_REFSWITCH_PAR_SET_POS_0                        = 64

    '-------------------------------------------------------------
    ' Stepper Read Status
    Public Const DAPI_STEPPER_STATUS_GET_POSITION                               = &H01
    Public Const DAPI_STEPPER_STATUS_GET_SWITCH                                 = &H02
    Public Const DAPI_STEPPER_STATUS_GET_ACTIVITY                               = &H03

    ' ----------------------------------------------------------------------------
    ' ----------------------------------------------------------------------------
    ' ----------------------------------------------------------------------------
    ' ----------------------------------------------------------------------------
    ' ----------------------------------------------------------------------------
    ' CAN-Defines

    ' ------------------------------------
    ' CAN Commands
    Public Const DAPI_CAN_CMD_SET_BITRATE                                       = 1
    Public Const DAPI_CAN_CMD_SET_MASK0                                         = 2
    Public Const DAPI_CAN_CMD_SET_RX_ADDRESS                                    = 3
    Public Const DAPI_CAN_CMD_CLR_TIMESTAMP                                     = 4
    Public Const DAPI_CAN_CMD_GET_BITRATE                                       = 5
    Public Const DAPI_CAN_CMD_GET_TIMESTAMP                                     = 6

    Public Const DAPI_CAN_CMD_TEST_GEN_RX_PACK                                  = &Hfffffff0

    Public Const DAPI_PAR_CAN_MESSAGE_BOX_0                                     = 0
    Public Const DAPI_PAR_CAN_MESSAGE_BOX_1                                     = 1
    Public Const DAPI_PAR_CAN_MESSAGE_BOX_2                                     = 2
    Public Const DAPI_PAR_CAN_MESSAGE_BOX_3                                     = 3

    Public Const DAPI_CAN_BITRATE_10000                                         = 10000
    Public Const DAPI_CAN_BITRATE_20000                                         = 20000
    Public Const DAPI_CAN_BITRATE_50000                                         = 50000
    Public Const DAPI_CAN_BITRATE_100000                                        = 100000
    Public Const DAPI_CAN_BITRATE_125000                                        = 125000
    Public Const DAPI_CAN_BITRATE_250000                                        = 250000
    Public Const DAPI_CAN_BITRATE_500000                                        = 500000
    Public Const DAPI_CAN_BITRATE_800000                                        = 800000
    Public Const DAPI_CAN_BITRATE_1000000                                       = 1000000

    Public Const DAPI_CAN_MASK_SINGLE                                           = &Hffffffff
    Public Const DAPI_CAN_MASK_ALL                                              = &H0

    ' ----------------------------------------------------------------------------
    ' ----------------------------------------------------------------------------
    ' ----------------------------------------------------------------------------
    ' ----------------------------------------------------------------------------
    ' ----------------------------------------------------------------------------
    ' CNT48 Commands

    Public Const DAPI_CNT48_FILTER_20ns                                         = &H0000
    Public Const DAPI_CNT48_FILTER_100ns                                        = &H1000
    Public Const DAPI_CNT48_FILTER_250ns                                        = &H2000
    Public Const DAPI_CNT48_FILTER_500ns                                        = &H3000
    Public Const DAPI_CNT48_FILTER_1us                                          = &H4000
    Public Const DAPI_CNT48_FILTER_2_5us                                        = &H5000
    Public Const DAPI_CNT48_FILTER_5us                                          = &H6000
    Public Const DAPI_CNT48_FILTER_10us                                         = &H7000
    Public Const DAPI_CNT48_FILTER_25us                                         = &H8000
    Public Const DAPI_CNT48_FILTER_50us                                         = &H9000
    Public Const DAPI_CNT48_FILTER_100us                                        = &HA000
    Public Const DAPI_CNT48_FILTER_250us                                        = &HB000
    Public Const DAPI_CNT48_FILTER_500us                                        = &HC000
    Public Const DAPI_CNT48_FILTER_1ms                                          = &HD000
    Public Const DAPI_CNT48_FILTER_2_5ms                                        = &HE000
    Public Const DAPI_CNT48_FILTER_5ms                                          = &HF000

    Public Const DAPI_CNT48_MODE_COUNT_RISING_EDGE                              = &H0000
    Public Const DAPI_CNT48_MODE_COUNT_RISING_EDGE_X2                           = &H0001
    Public Const DAPI_CNT48_MODE_COUNT_RISING_EDGE_X4                           = &H0002
    Public Const DAPI_CNT48_MODE_T                                              = &H000D
    Public Const DAPI_CNT48_MODE_FREQUENCY                                      = &H000E
    Public Const DAPI_CNT48_MODE_PWM                                            = &H000F

    Public Const DAPI_CNT48_SUBMODE_NO_RESET                                    = &H0000
    Public Const DAPI_CNT48_SUBMODE_RESET_WITH_READ                             = &H0010
    Public Const DAPI_CNT48_SUBMODE_NO_RESET_NO_HW_RESET                        = &H0020
    Public Const DAPI_CNT48_SUBMODE_RESET_WITH_READ_NO_HW_RESET                 = &H0030
    Public Const DAPI_CNT48_SUBMODE_RESET_ON_CH_7                               = &H0070
    Public Const DAPI_CNT48_SUBMODE_LATCH_COMMON                                = &H0080
    Public Const DAPI_CNT48_SUBMODE_FREQUENCY_TIME_BASE_1ms                     = &H0030
    Public Const DAPI_CNT48_SUBMODE_FREQUENCY_TIME_BASE_10ms                    = &H0020
    Public Const DAPI_CNT48_SUBMODE_FREQUENCY_TIME_BASE_100ms                   = &H0010
    Public Const DAPI_CNT48_SUBMODE_FREQUENCY_TIME_BASE_1sec                    = &H0000

    ' ----------------------------------------------------------------------------
    ' ----------------------------------------------------------------------------
    ' ----------------------------------------------------------------------------
    ' ----------------------------------------------------------------------------
    ' ----------------------------------------------------------------------------
    ' Software FIFO Commands

    Public Const DAPI_FIFO_TYPE_READ_AD_FIFO                                    = &H01

    ' ----------------------------------------------------------------------------
    ' ----------------------------------------------------------------------------
    ' ----------------------------------------------------------------------------
    ' ----------------------------------------------------------------------------
    ' ----------------------------------------------------------------------------
    ' PWM Commands

    Public Const DAPI_PWM_FREQUENCY_10HZ                                        = 1
    Public Const DAPI_PWM_FREQUENCY_100HZ                                       = 10
    Public Const DAPI_PWM_FREQUENCY_250HZ                                       = 25
    Public Const DAPI_PWM_FREQUENCY_1000HZ                                      = 100
    Public Const DAPI_PWM_FREQUENCY_SERVO_M1                                    = 254

    ' ----------------------------------------------------------------------------
    ' ----------------------------------------------------------------------------
    ' ----------------------------------------------------------------------------
    ' ----------------------------------------------------------------------------
    ' ----------------------------------------------------------------------------
    ' Definitions for DapiOpenEx

    Friend Structure DAPI_OPENMODULEEX_STRUCT
        <MarshalAs(UnmanagedType.ByValTStr, SizeConst:=256)> _
        Dim address As String
        Dim timeout As UInt32
        Dim portno As UInt32
        Dim encryption_type As UInt32
        <MarshalAs(UnmanagedType.ByValTStr, SizeConst:=32)> _
        Dim encryption_password As String
    End Structure

    Public Const DAPI_OPEN_MODULE_OPTION_USE_EXBUFFER                           = (1<<0)    ' Bit 0
    Public Const DAPI_OPEN_MODULE_OPTION_NO_RESCAN                              = (1<<1)    ' Bit 1
    Public Const DAPI_OPEN_MODULE_OPTION_CANOPENSTICK_NO_REGISTER_REROUTE	= (1<<2)    ' Bit 2

    Public Const DAPI_OPEN_MODULE_ENCRYPTION_TYPE_NONE                          = 0
    Public Const DAPI_OPEN_MODULE_ENCRYPTION_TYPE_NORMAL                        = 1
    Public Const DAPI_OPEN_MODULE_ENCRYPTION_TYPE_ADMIN                         = 2
    Public Const DAPI_OPEN_MODULE_ENCRYPTION_TYPE_ADMIN_TEMP                    = 3

    ' ----------------------------------------------------------------------------
    ' ----------------------------------------------------------------------------
    ' ----------------------------------------------------------------------------
    ' ----------------------------------------------------------------------------
    ' ----------------------------------------------------------------------------
        
End Class
