//***********************************************************************************
//***********************************************************************************
//***********************************************************************************
//***********************************************************************************
//***********************************************************************************
//
//
//
// 	delib_error_codes.pas
//  project: DELIB
//
//
//  (c) DEDITEC GmbH, 2009-2018
//  web: http://www.deditec.de/
//  mail: vertrieb@deditec.de
//
//
//***********************************************************************************
//***********************************************************************************
//***********************************************************************************
//***********************************************************************************
//***********************************************************************************
//
    // ----------------------------------------------------------------------------
    // ----------------------------------------------------------------------------
    //	= $0000		
    // ----------------------------------------------------------------------------
    // ----------------------------------------------------------------------------
    //
const	
	DAPI_ERR_NONE												= 0;
    //
    // ----------------------------------------------------------------------------
    // ----------------------------------------------------------------------------
    //	= $0100		Allgemeine Error Codes
    // ----------------------------------------------------------------------------
    // ----------------------------------------------------------------------------
    //
const	
	DAPI_ERR_GEN_CLASS											= $0100;
	
	DAPI_ERR_GEN_MALLOC_ERROR									= $0101;
	DAPI_ERR_GEN_BUFFER_TOO_SMALL_ERROR							= $0102;
	DAPI_ERR_GEN_ERROR_WITH_TEXT								= $0103;

	DAPI_ERR_GEN_SOCKET_ERROR									= $0110;
	DAPI_ERR_GEN_BINDING_ERROR									= $0111;
	DAPI_ERR_GEN_SIG_HANDLER_ERROR								= $0112;

	DAPI_ERR_GEN_UNKNOWN_ENCRYPTION_TYPE						= $0120;
	DAPI_ERR_GEN_ENCRYPTION_ERROR								= $0121;

	DAPI_ERR_GEN_ILLEGAL_MODULE_ID								= $0130;
	DAPI_ERR_GEN_ILLEGAL_MODULE_NR								= $0131;
	DAPI_ERR_GEN_ILLEGAL_HANDLE									= $0132;

	DAPI_ERR_GEN_NOT_SUPPORTED_MODE								= $0140;
	DAPI_ERR_GEN_NOT_SUPPORTED_IO_TYPE							= $0141;
	DAPI_ERR_GEN_NOT_SUPPORTED_CHANNEL							= $0142;
	DAPI_ERR_GEN_NOT_SUPPORTED_SW_FEATURE						= $0143;
	DAPI_ERR_GEN_NOT_SUPPORTED_FUNCTION							= $0144;
    //
    // ----------------------------------------------------------------------------
    // ----------------------------------------------------------------------------
    //	= $0200	Communication Errors
    // ----------------------------------------------------------------------------
    // ----------------------------------------------------------------------------
    //
const	
	DAPI_ERR_COM_CLASS											= $0200;

	DAPI_ERR_COM_CONN_COULD_NOT_BE_ESTABLISHED					= $0201;
	DAPI_ERR_COM_DEVICE_DID_NOT_ANSWER							= $0202;
	
	DAPI_ERR_COM_HANDLE_INVALID									= $0210;
	DAPI_ERR_COM_DELIB_ID_INVALID								= $0211;
	DAPI_ERR_COM_FT_HANDLE_INVALID								= $0212;
	DAPI_ERR_COM_FT_ERROR										= $0213;
    //
    // ----------------------------------------------------------------------------
    // ----------------------------------------------------------------------------
    //	= $0300	Device Errors
    // ----------------------------------------------------------------------------
    // ----------------------------------------------------------------------------
    //
const	
	DAPI_ERR_DEV_CLASS											= $0300;
    
	DAPI_ERR_DEV_PKT_CMD_ILLEGAL								= $0301;		//ehemals ERR_EXECUTE_RS232_RX_COMMAND_ILLEGAL_COMMAND     1
	DAPI_ERR_DEV_PKT_DATA_LENGTH_ERROR							= $0302;		//ehemals ERR_EXECUTE_RS232_RX_COMMAND_WRONG_DATA_LENGTH   2
	DAPI_ERR_DEV_PKT_DATA_CHECKSUM_ERROR						= $0303;		//ehemals ERR_EXECUTE_RS232_RX_COMMAND_WRONG_CHECKSUM      3
	DAPI_ERR_DEV_PKT_ADDR_NOT_FOR_ME							= $0304;		//ehemals ERR_EXECUTE_RS232_RX_COMMAND_NOT_FOR_ME			 4
	DAPI_ERR_DEV_PKT_OTHER_ERROR								= $0305;		//ehemals ERR_EXECUTE_RS232_RX_COMMAND_NOT_FOR_ME			 4
    
	DAPI_ERR_DEV_PACKET_CMD_NOT_SUPPORTED						= $0310;		// BC-CMD or TCP-CMD
	DAPI_ERR_DEV_PACKET_ID_1_NOT_ALLOWED						= $0311;		// TCP
	DAPI_ERR_DEV_PACKET_ID_1_NOT_SUPPORTED						= $0312;		// TCP
	DAPI_ERR_DEV_PACKET_HEADER_NOT_OK							= $0313;		// TCP
	DAPI_ERR_DEV_PACKET_SUBCMD_NOT_SUPPORTED          			= $0314;		// TCP
    
	DAPI_ERR_DEV_IO_ADDR_ILLEGAL								= $0331;		// dev_io
	DAPI_ERR_DEV_IO_RD_WR_ERROR									= $0332;		// dev_io
	DAPI_ERR_DEV_IO_SUB_ADDR_ILLEGAL							= $0333;		// dev_io
	DAPI_ERR_DEV_IO_OTHER_ERROR									= $0337;		// dev_io (7. von 7 mglichen Errors)
	DAPI_ERR_DEV_IO_HTML_ACCESS_DENIED							= $0338;
    
	DAPI_ERR_DEV_FS_INTERNAL_TEXT_BUFFER_TOO_SMALL				= $0345;
	DAPI_ERR_DEV_FS_RW_OFFSET_OUT_OF_SCOPE						= $0346;
	DAPI_ERR_DEV_FS_RW_LENGTH_OUT_OF_SCOPE						= $0347;
	DAPI_ERR_DEV_FS_BUFFER_TOO_SMALL							= $0349;
	
	DAPI_ERR_DEV_FILE_WRITE_ERROR								= $0370;
    
	DAPI_ERR_DEV_CONFIG_WRITE_PROTECTED							= $0380;
	DAPI_ERR_DEV_CONFIG_KEY_NOT_PRESSED							= $0381;
	DAPI_ERR_DEV_CONFIG_READ_ERROR								= $0382;
	DAPI_ERR_DEV_CONFIG_WRITE_ERROR								= $0383;
	DAPI_ERR_DEV_CONFIG_UPDATE_ERROR							= $0384;		// Broadcast
	DAPI_ERR_DEV_CONFIG_PARAM_ONLY_ONE_TIME_WRITEABLE			= $0385;		// ETH
	DAPI_ERR_DEV_CONFIG_PARAM_IS_READ_ONLY						= $0386;
	DAPI_ERR_DEV_CONFIG_PARAM_IS_WRITE_ONLY						= $0387;
	DAPI_ERR_DEV_CONFIG_WRITE_PROTECTED_SW						= $0388;
	DAPI_ERR_DEV_CONFIG_FS_INVALID								= $0389;
	DAPI_ERR_DEV_CONFIG_FS_DIR_NOT_FOUND						= $038a;
	DAPI_ERR_DEV_CONFIG_FS_DIR_ALREADY_EXIST					= $038b;
	DAPI_ERR_DEV_CONFIG_FS_IS_FULL								= $038c;
	DAPI_ERR_DEV_CONFIG_FS_DIR_DATA_INVALID                   	= $038d;
    
	DAPI_ERR_DEV_ENCRYPTED_HEADER_NOT_OK						= $0391;
	DAPI_ERR_DEV_ENCRYPTION_ERROR								= $0392;		// Encryption
	DAPI_ERR_DEV_ENCRYPTION_TEMP_ADMIN_MODE_NOT_ALLOWED			= $0393;
	DAPI_ERR_DEV_ENCRYPTION_NO_ADMIN_RIGHTS						= $0394;
    
	DAPI_ERR_DEV_EXECUTE_CMD_ERROR								= $03FF;
    //
    // ----------------------------------------------------------------------------
    // ----------------------------------------------------------------------------
    // ----------------------------------------------------------------------------
    // ----------------------------------------------------------------------------
    // ----------------------------------------------------------------------------
