' ****************************************************************************
' ****************************************************************************
' ****************************************************************************
' ****************************************************************************
' ****************************************************************************
'
'
'
' delib_error_codes.vb
' project: DELIB
'
'
' (c) DEDITEC GmbH, 2009-2018
' web: http://www.deditec.de/
' mail: vertrieb@deditec.de
'
'
' ****************************************************************************
' ****************************************************************************
' ****************************************************************************
' ****************************************************************************
' ****************************************************************************
'

Partial Friend Class DELib

    ' ----------------------------------------------------------------------------
    ' ----------------------------------------------------------------------------
    '   = &H0000        
    ' ----------------------------------------------------------------------------
    ' ----------------------------------------------------------------------------
    '
    Public Const DAPI_ERR_NONE                                              = 0
    '
    ' ----------------------------------------------------------------------------
    ' ----------------------------------------------------------------------------
    '   = &H0100        Allgemeine Error Codes
    ' ----------------------------------------------------------------------------
    ' ----------------------------------------------------------------------------
    '
    Public Const DAPI_ERR_GEN_CLASS                                         = &H0100
    '
    Public Const DAPI_ERR_GEN_MALLOC_ERROR                                  = &H0101
    Public Const DAPI_ERR_GEN_BUFFER_TOO_SMALL_ERROR                        = &H0102
    Public Const DAPI_ERR_GEN_ERROR_WITH_TEXT                               = &H0103
    '
    Public Const DAPI_ERR_GEN_SOCKET_ERROR                                  = &H0110
    Public Const DAPI_ERR_GEN_BINDING_ERROR                                 = &H0111
    Public Const DAPI_ERR_GEN_SIG_HANDLER_ERROR                             = &H0112
    '
    Public Const DAPI_ERR_GEN_UNKNOWN_ENCRYPTION_TYPE                       = &H0120
    Public Const DAPI_ERR_GEN_ENCRYPTION_ERROR                              = &H0121
    '
    Public Const DAPI_ERR_GEN_ILLEGAL_MODULE_ID                             = &H0130
    Public Const DAPI_ERR_GEN_ILLEGAL_MODULE_NR                             = &H0131
    Public Const DAPI_ERR_GEN_ILLEGAL_HANDLE                                = &H0132
    '
    Public Const DAPI_ERR_GEN_NOT_SUPPORTED_MODE                            = &H0140
    Public Const DAPI_ERR_GEN_NOT_SUPPORTED_IO_TYPE                         = &H0141
    Public Const DAPI_ERR_GEN_NOT_SUPPORTED_CHANNEL                         = &H0142
    Public Const DAPI_ERR_GEN_NOT_SUPPORTED_SW_FEATURE                      = &H0143
    Public Const DAPI_ERR_GEN_NOT_SUPPORTED_FUNCTION                        = &H0144
    '
    ' ----------------------------------------------------------------------------
    ' ----------------------------------------------------------------------------
    '   = &H0200    Communication Errors
    ' ----------------------------------------------------------------------------
    ' ----------------------------------------------------------------------------
    '
    Public Const DAPI_ERR_COM_CLASS                                         = &H0200
    '
    Public Const DAPI_ERR_COM_CONN_COULD_NOT_BE_ESTABLISHED                 = &H0201
    Public Const DAPI_ERR_COM_DEVICE_DID_NOT_ANSWER                         = &H0202
    '
    Public Const DAPI_ERR_COM_HANDLE_INVALID                                = &H0210
    Public Const DAPI_ERR_COM_DELIB_ID_INVALID                              = &H0211
    Public Const DAPI_ERR_COM_FT_HANDLE_INVALID                             = &H0212
    Public Const DAPI_ERR_COM_FT_ERROR                                      = &H0213
    '
    ' ----------------------------------------------------------------------------
    ' ----------------------------------------------------------------------------
    '   = &H0300    Device Errors
    ' ----------------------------------------------------------------------------
    ' ----------------------------------------------------------------------------
    '
    Public Const DAPI_ERR_DEV_CLASS                                         = &H0300
    '
    Public Const DAPI_ERR_DEV_PKT_CMD_ILLEGAL                               = &H0301        'ehemals ERR_EXECUTE_RS232_RX_COMMAND_ILLEGAL_COMMAND     1
    Public Const DAPI_ERR_DEV_PKT_DATA_LENGTH_ERROR                         = &H0302        'ehemals ERR_EXECUTE_RS232_RX_COMMAND_WRONG_DATA_LENGTH   2
    Public Const DAPI_ERR_DEV_PKT_DATA_CHECKSUM_ERROR                       = &H0303        'ehemals ERR_EXECUTE_RS232_RX_COMMAND_WRONG_CHECKSUM      3
    Public Const DAPI_ERR_DEV_PKT_ADDR_NOT_FOR_ME                           = &H0304        'ehemals ERR_EXECUTE_RS232_RX_COMMAND_NOT_FOR_ME          4
    Public Const DAPI_ERR_DEV_PKT_OTHER_ERROR                               = &H0305        'ehemals ERR_EXECUTE_RS232_RX_COMMAND_NOT_FOR_ME          4
    '
    Public Const DAPI_ERR_DEV_PACKET_CMD_NOT_SUPPORTED                      = &H0310        ' BC-CMD or TCP-CMD
    Public Const DAPI_ERR_DEV_PACKET_ID_1_NOT_ALLOWED                       = &H0311        ' TCP
    Public Const DAPI_ERR_DEV_PACKET_ID_1_NOT_SUPPORTED                     = &H0312        ' TCP
    Public Const DAPI_ERR_DEV_PACKET_HEADER_NOT_OK                          = &H0313        ' TCP
    Public Const DAPI_ERR_DEV_PACKET_SUBCMD_NOT_SUPPORTED                   = &H0314        ' TCP
    '
    Public Const DAPI_ERR_DEV_IO_ADDR_ILLEGAL                               = &H0331        ' dev_io
    Public Const DAPI_ERR_DEV_IO_RD_WR_ERROR                                = &H0332        ' dev_io
    Public Const DAPI_ERR_DEV_IO_SUB_ADDR_ILLEGAL                           = &H0333        ' dev_io
    Public Const DAPI_ERR_DEV_IO_OTHER_ERROR                                = &H0337        ' dev_io (7. von 7 mglichen Errors)
    Public Const DAPI_ERR_DEV_IO_HTML_ACCESS_DENIED                         = &H0338
    '
    Public Const DAPI_ERR_DEV_FS_INTERNAL_TEXT_BUFFER_TOO_SMALL             = &H0345
    Public Const DAPI_ERR_DEV_FS_RW_OFFSET_OUT_OF_SCOPE                     = &H0346
    Public Const DAPI_ERR_DEV_FS_RW_LENGTH_OUT_OF_SCOPE                     = &H0347
    Public Const DAPI_ERR_DEV_FS_BUFFER_TOO_SMALL                           = &H0349
    '
    Public Const DAPI_ERR_DEV_FILE_WRITE_ERROR                              = &H0370
    '
    Public Const DAPI_ERR_DEV_CONFIG_WRITE_PROTECTED                        = &H0380
    Public Const DAPI_ERR_DEV_CONFIG_KEY_NOT_PRESSED                        = &H0381
    Public Const DAPI_ERR_DEV_CONFIG_READ_ERROR                             = &H0382
    Public Const DAPI_ERR_DEV_CONFIG_WRITE_ERROR                            = &H0383
    Public Const DAPI_ERR_DEV_CONFIG_UPDATE_ERROR                           = &H0384        ' Broadcast
    Public Const DAPI_ERR_DEV_CONFIG_PARAM_ONLY_ONE_TIME_WRITEABLE          = &H0385        ' ETH
    Public Const DAPI_ERR_DEV_CONFIG_PARAM_IS_READ_ONLY                     = &H0386
    Public Const DAPI_ERR_DEV_CONFIG_PARAM_IS_WRITE_ONLY                    = &H0387
    Public Const DAPI_ERR_DEV_CONFIG_WRITE_PROTECTED_SW                     = &H0388
    Public Const DAPI_ERR_DEV_CONFIG_FS_INVALID                             = &H0389
    Public Const DAPI_ERR_DEV_CONFIG_FS_DIR_NOT_FOUND                       = &H038a
    Public Const DAPI_ERR_DEV_CONFIG_FS_DIR_ALREADY_EXIST                   = &H038b
    Public Const DAPI_ERR_DEV_CONFIG_FS_IS_FULL                             = &H038c
    Public Const DAPI_ERR_DEV_CONFIG_FS_DIR_DATA_INVALID                    = &H038d
    '
    Public Const DAPI_ERR_DEV_ENCRYPTED_HEADER_NOT_OK                       = &H0391
    Public Const DAPI_ERR_DEV_ENCRYPTION_ERROR                              = &H0392        ' Encryption
    Public Const DAPI_ERR_DEV_ENCRYPTION_TEMP_ADMIN_MODE_NOT_ALLOWED        = &H0393
    Public Const DAPI_ERR_DEV_ENCRYPTION_NO_ADMIN_RIGHTS                    = &H0394
    '
    Public Const DAPI_ERR_DEV_EXECUTE_CMD_ERROR                             = &H03FF
    '
    ' ----------------------------------------------------------------------------
    ' ----------------------------------------------------------------------------
    ' ----------------------------------------------------------------------------
    ' ----------------------------------------------------------------------------
    ' ----------------------------------------------------------------------------

End Class
