//***********************************************************************************
//***********************************************************************************
//***********************************************************************************
//***********************************************************************************
//***********************************************************************************
//
//
//
//	delib_extended_structs.h
//	project: delib
//
//
//	(c) DEDITEC GmbH, 2016
//	web: http://www.deditec.de/
//	mail: vertrieb@deditec.de
//
// 
//***********************************************************************************
//***********************************************************************************
//***********************************************************************************
//***********************************************************************************
//***********************************************************************************

typedef struct _CanDevCfg
{
	/*
	#define DT_EE_FILESYSTEM_DIR_TYPE_CAN_DEV_CFG				0x10
	#define DT_EE_FS_DIR_TYPE_CAN_DEV_CFG_SIZE					64
	*/

	// Pos: 0-3
	unsigned long can_adress_rx_deditec_commands;
	// can-id vom interface - max 29bit

	// Pos: 4-7
	unsigned long can_adress_answer_deditec_commands;
	// response-id vom interface - max 29bit

	// Pos: 8-11
	unsigned long init_timeout_value;
	/*
	0 = disabled
	1 = 0,1 sec
	2 = 0,2 sec
	..
	99 = 9,9 sec
	100 = 10 sec
	*/

	// general
	// Pos: 12-15
	unsigned char header[4];
	/*
	WIRD NICHT ANGEZEIGT!!! wird nur "intern benoetigt" - RO/NET/BS usw. Modul fragt diesen Header ab und startet CAN nur, wenn der Header ok ist !
	sess.canDevCfg.header[0] = 0x12;
	sess.canDevCfg.header[1] = 0x59;
	sess.canDevCfg.header[2] = 0x47;
	sess.canDevCfg.header[3] = 0x13;
	 */

	// device
	// Pos: 16
	unsigned char baudrate;
	/*
	0 = 1 MBit/s
	1 = 500 KBit/s
	2 = 250 KBit/s
	3 = 125 KBit/s
	4 = 100 KBit/s
	5 = 50 KBit/s
	6 = 20 KBit/s
	7 = 10 KBit/s
	*/

	// Pos: 17
	unsigned char useExtID;
	/*
	Adress Modus
	0 = 11bit
	1 = 29bit
	*/

	// io init
	// Pos: 18
	unsigned char init_ad_filter;
	/*
	0x00 = None
	0x05 = Medium
	0x0a = High
	*/

	// Pos: 19
	unsigned char init_ad_mode;
	// Pos: 20
	unsigned char init_da_mode;
	/*
	#define DAPI_ADDA_MODE_UNIPOL_10V								0x00
	#define DAPI_ADDA_MODE_UNIPOL_5V								0x01
	#define DAPI_ADDA_MODE_UNIPOL_2V5								0x02

	#define DAPI_ADDA_MODE_BIPOL_10V								0x40
	#define DAPI_ADDA_MODE_BIPOL_5V									0x41
	#define DAPI_ADDA_MODE_BIPOL_2V5								0x42

	#define DAPI_ADDA_MODE_0_20mA									0x80
	#define DAPI_ADDA_MODE_4_20mA									0x81
	#define DAPI_ADDA_MODE_0_24mA									0x82
	#define DAPI_ADDA_MODE_0_50mA									0x84

	#define DAPI_ADDA_MODE_0_20mA_TESTMODE							0xfe	NUR AD
	#define DAPI_ADDA_MODE_BIPOL_10V_TESTMODE						0xff	NUR AD
	*/

	// Pos: 21
	unsigned char init_cnt16_mode;
	/*
	0 = 16 Bit Counter (default)
	1 = 16 Bit up/down Counter
	*/

	// Pos: 22
	unsigned char init_cnt8_mode;
	/*
	init_cnt8_mode = "((hauptmodus | submodus) & 0xff)"
	---
	hauptmodi:
	#define DAPI_CNT48_MODE_COUNT_RISING_EDGE					0x0000
	#define DAPI_CNT48_MODE_COUNT_RISING_EDGE_X2              	0x0001
	#define DAPI_CNT48_MODE_COUNT_RISING_EDGE_X4              	0x0002
	#define DAPI_CNT48_MODE_T									0x000D
	#define DAPI_CNT48_MODE_FREQUENCY							0x000E
	#define DAPI_CNT48_MODE_PWM									0x000F
	---
	submodi fuer die 3 COUNT_RISING_EDGE:
	#define DAPI_CNT48_SUBMODE_NO_RESET							0x0000
	#define DAPI_CNT48_SUBMODE_RESET_WITH_READ 					0x0010
	#define DAPI_CNT48_SUBMODE_NO_RESET_NO_HW_RESET             0x0020
	#define DAPI_CNT48_SUBMODE_RESET_WITH_READ_NO_HW_RESET      0x0030
	#define DAPI_CNT48_SUBMODE_RESET_ON_CH_7 					0x0070
	#define DAPI_CNT48_SUBMODE_LATCH_COMMON 					0x0080
	---
	submodi fuer rest:
	#define DAPI_CNT48_SUBMODE_FREQUENCY_TIME_BASE_1ms			0x0030
	#define DAPI_CNT48_SUBMODE_FREQUENCY_TIME_BASE_10ms			0x0020
	#define DAPI_CNT48_SUBMODE_FREQUENCY_TIME_BASE_100ms		0x0010
	#define DAPI_CNT48_SUBMODE_FREQUENCY_TIME_BASE_1sec			0x0000
	*/

	// Pos: 23
	unsigned char init_cnt8_filter;
	/*
	init_cnt8_filter = "((filter >> 8) & 0xff)"
	#define DAPI_CNT48_FILTER_20ns								0x0000
	#define DAPI_CNT48_FILTER_100ns								0x1000
	#define DAPI_CNT48_FILTER_250ns								0x2000
	#define DAPI_CNT48_FILTER_500ns								0x3000
	#define DAPI_CNT48_FILTER_1us								0x4000
	#define DAPI_CNT48_FILTER_2_5us								0x5000
	#define DAPI_CNT48_FILTER_5us								0x6000
	#define DAPI_CNT48_FILTER_10us								0x7000
	#define DAPI_CNT48_FILTER_25us								0x8000
	#define DAPI_CNT48_FILTER_50us								0x9000
	#define DAPI_CNT48_FILTER_100us								0xA000
	#define DAPI_CNT48_FILTER_250us								0xB000
	#define DAPI_CNT48_FILTER_500us								0xC000
	#define DAPI_CNT48_FILTER_1ms								0xD000
	#define DAPI_CNT48_FILTER_2_5ms								0xE000
	#define DAPI_CNT48_FILTER_5ms								0xF000
	*/

	// Pos: 24
	unsigned char init_timeout_mode;
	/*
	0 = disabled
	1,2,3... = DELIB TIMEOUT Modi
	*/

	// Pos: 25-63
	unsigned char dummy[39];			// platzhalter damit struct auf 64byte kommt
} CanDevCfg;

// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------

typedef struct _CanTxCfg
{
	/*
	#define DT_EE_FILESYSTEM_DIR_TYPE_CAN_TX_CFG				0x12
	#define DT_EE_FS_DIR_TYPE_CAN_TX_CFG_SIZE					64
	*/

	unsigned long canID;
	// can-id, an die der TX-Modus schicken soll - max 29bit

	unsigned char isActive;
	/*
	0 = disabled
	1 = timer		-> 2x combobox: 1)zahl[1..9] + 2)1ms/10ms/100ms/1sec
	2 = rx-event	-> combobox mit rx auswahl
	3 = FAP
	*/

	unsigned char useExtID;
	/*
	Adress Modus
	0 = 11bit
	1 = 29bit
	*/

	unsigned char interval;
	/*
	nur bei "isActive == 1"
	switch (sess.canTxCfg[i].interval & 0xf)
	{
		case 0x01: timer_ms = ((sess.canTxCfg[i].interval >> 4) & 0xf) * 1; break;
		case 0x02: timer_ms = ((sess.canTxCfg[i].interval >> 4) & 0xf) * 10; break;
		case 0x03: timer_ms = ((sess.canTxCfg[i].interval >> 4) & 0xf) * 100; break;
		case 0x04: timer_ms = ((sess.canTxCfg[i].interval >> 4) & 0xf) * 1000; break;
	}
	*/

	unsigned char mode;
	/*
	1 = OPTO-IN 1-64
	2 = A/D CH 1-4
	3 = A/D CH 5-8
	4 = A/D CH 9-12
	5 = A/D CH 13-16
	6 = A/D CH 17-20
	7 = A/D CH 21-24
	8 = A/D CH 25-28
	9 = A/D CH 29-32
	10 = Counter16 1-4   (16 Bit)
	11 = Counter16 5-8   (16 Bit)
	12 = Counter16 9-12  (16 Bit)
	13 = Counter16 13-16 (16 Bit)
	14 = Counter16 17-20 (16 Bit)
	15 = Counter16 21-24 (16 Bit)
	16 = Counter16 25-28 (16 Bit)
	17 = Counter16 29-32 (16 Bit)
	18 = Cnt48 1-2 (32 Bit)
	19 = Cnt48 3-4 (32 Bit)
	20 = Cnt48 5-6 (32 Bit)
	21 = Cnt48 7-8 (32 Bit)
	22 = PT-100 1-2 (32 Bit)
	23 = PT-100 3-4 (32 Bit)
	24 = PT-100 5-6 (32 Bit)
	25 = PT-100 7-8 (32 Bit)
	26 = Cnt48 1 (64 Bit)
	27 = Cnt48 2 (64 Bit)
	28 = Cnt48 3 (64 Bit)
	29 = Cnt48 4 (64 Bit)
	30 = Testcounter 8 bit
	31 = Custom1
	32 = Custom2
	33 = Custom3
	*/

} CanTxCfg;

// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------

typedef struct _CanRxCfg
{
	/*
	#define DT_EE_FILESYSTEM_DIR_TYPE_CAN_RX_CFG				0x11
	#define DT_EE_FS_DIR_TYPE_CAN_RX_CFG_SIZE					64
	*/

	unsigned long canID;
	// can-id, auf die der RX-Modus reagieren soll - max 29bit

	unsigned char isActive;
	/*
	0 = disabled
	1 = enabled
	*/

	unsigned char useExtID;
	/*
	Adress Modus
	0 = 11bit
	1 = 29bit
	*/

	unsigned char mode;
	/*
	1 = Digital Out 1-64
	2 = D/A CH 1-4
	3 = D/A CH 5-8
	4 = D/A CH 9-12
	5 = D/A CH 13-16
	6 = D/A CH 17-20
	7 = D/A CH 21-24
	8 = D/A CH 25-28
	9 = D/A CH 29-32
	10 = Stepper No. 1
	11 = Stepper No. 2
	12 = Stepper No. 3
	13 = Stepper No. 4
	14 = Stepper No. 5
	15 = Stepper No. 6
	16 = Stepper No. 7
	17 = Stepper No. 8
	18 = D/A CH 1-4 (custom)
	19 = D/A CH 5-8 (custom)
	20 = D/A CH 9-12 (custom)
	21 = D/A CH 13-16 (custom)
	22 = D/A CH 17-20 (custom)
	23 = D/A CH 21-24 (custom)
	24 = D/A CH 25-28 (custom)
	25 = D/A CH 29-32 (custom)
	26 = Trigger Auto TX 1
	27 = Trigger Auto TX 2
	28 = Trigger Auto TX 3
	29 = Trigger Auto TX 4
	30 = Custom1
	31 = Custom2
	32 = Custom3
	*/

	unsigned char dummy;				// platzhalter damit struct auf 8byte kommt
} CanRxCfg;

// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------

typedef struct _NTPCfg
{
	/*
	#define DT_EE_FILESYSTEM_DIR_TYPE_NTP						0x86
	#define DT_EE_FS_DIR_TYPE_NTP_SIZE 							40
	*/

	unsigned long port;
	char server[32];

	unsigned char isActive;
	unsigned char timezoneHtmlIndex;

	// CC	05.12.2016
	unsigned char serverIsActive;
	unsigned char serverTimeValidation;
} NTPCfg;

// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------

typedef struct _UsrMgrCfg
{
	/*
	#define DT_EE_FILESYSTEM_DIR_TYPE_USR_MGR_CFG				0x89
	#define DT_EE_FS_DIR_TYPE_USR_MGR_CFG_SIZE					36
	*/

	unsigned char isRequired;
	// 0 = disabled, 1 = enabled

	unsigned char sessionTime[2];
	/*
	sess.usrMgrCfg.sessionTime[0] = ((value_numeric >> 0) & 0xff);
	sess.usrMgrCfg.sessionTime[1] = ((value_numeric >> 8) & 0xff);
	*/

	unsigned char dummy;				// platzhalter damit struct auf gerade anzahl bytes kommt
	char user[16];
	char pw[16];

} UsrMgrCfg;

// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------

typedef struct _SerCfg
{
	/*
	#define DT_EE_FILESYSTEM_DIR_TYPE_SER_DEV_CFG				0x20
	#define DT_EE_FS_DIR_TYPE_SER_DEV_CFG_SIZE					8
	*/

	unsigned char useSpecialMode;
	// 0 = benutze MOD_CFG_MEM-Config, 1 = Vorzugsmodus (115200 Baud, mod-nr = 0, Echo = Off, Register-Modus = On)

	unsigned char baudrate;
	/*
	0 = 1250000		ACHTUNG: Ruecksprache JS: die baudrate faellt wohl weg
	1 = 625000
	2 = 250000
	3 = 125000
	4 = 115200
	5 = 57600
	6 = 50000
	7 = 38400
	8 = 19200
	9 = 9600
	10 = 4800
	11 = 2400
	12 = 1200
	13 = 600
	14 = 300
	*/

	unsigned char rs485_mod_nr;

	unsigned char isSerialEcho;
	// 0 = disabled, 1 = enabled

	unsigned char isRegisterMode;
	// 0 = textmodus, 1 = register-modus

	unsigned char dummy[3];		// platzhalter damit struct auf 8 bytes kommt

} SerCfg;

// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------

typedef struct _EncCfg
{
	/*
	#define DT_EE_FILESYSTEM_DIR_TYPE_ENCRYPTION				0x85
	#define DT_EE_FS_DIR_TYPE_ENCRYPTION_SIZE 					36
	*/

	unsigned char allow_protocol_unencrypted;
	unsigned char allow_protocol_encrypted_normal;
	unsigned char allow_protocol_encrypted_admin;
	unsigned char allow_html_io_access;
	char pw_normal[16];
	char pw_admin[16];

} EncCfg;

// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------

typedef struct _WIFI_Cfg
{
	/*
	#define DT_EE_FILESYSTEM_DIR_TYPE_WIFI_CFG					0x8d
	#define DT_EE_FS_DIR_TYPE_WIFI_SIZE 						68
	*/

	unsigned long enabled;

	char ssid[32];
	char pwd[32];
} WIFI_Cfg;

// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------

#ifdef PRODUCT_GROUP_NET
/*
#define DT_EE_FILESYSTEM_DIR_TYPE_SUBMODULE_IO_CFG			0x40
#define DT_EE_FS_DIR_TYPE_SUBMODULE_IO_CFG_SIZE 			1024	// 16*64

#define DT_EE_FILESYSTEM_DIR_TYPE_SUBMODULE_IO_NAMES		0x41
#define DT_EE_FS_DIR_TYPE_SUBMODULE_IO_NAMES_SIZE 			256		// 16*16
*/

#define IO_CFG_TYPE_DI		0
#define IO_CFG_TYPE_DO		1
#define IO_CFG_TYPE_AI		2
#define IO_CFG_TYPE_AO		3
#define IO_CFG_TYPE_TEMP	4

typedef struct _IOCfgDI
{
	unsigned long type;
	unsigned long ff_filter;
	unsigned long cnt_mode;
} IOCfgDI;

typedef struct _IOCfgDO
{
	unsigned long type;
	unsigned long value;
	unsigned long pwm_freq;
} IOCfgDO;

typedef struct _IOCfgAI
{
	unsigned long type;
	unsigned long mode;
	unsigned long filter;
} IOCfgAI;

typedef struct _IOCfgAO
{
	unsigned long type;
	unsigned long value;
	unsigned long mode;
	unsigned long enabled;
	unsigned long slew_rate;
	unsigned long slew_rate_clk;
} IOCfgAO;

typedef struct _IOCfgTemp
{
	unsigned long type;
	unsigned long sensor_type;
	unsigned long resistor;
} IOCfgTemp;
#endif
